"use strict";var _a,_b,_c,_d,_e,_f,_g;Object.defineProperty(exports,"__esModule",{value:!0}),exports.ResourceType=exports.ManagedRuleIdentifiers=exports.CustomPolicy=exports.CustomRule=exports.ManagedRule=exports.MaximumExecutionFrequency=exports.RuleScope=exports.EvaluationMode=void 0;var jsiiDeprecationWarnings=()=>{var tmp=require("../../.warnings.jsii.js");return jsiiDeprecationWarnings=()=>tmp,tmp};const JSII_RTTI_SYMBOL_1=Symbol.for("jsii.rtti");var crypto_1=()=>{var tmp=require("crypto");return crypto_1=()=>tmp,tmp},config_generated_1=()=>{var tmp=require("./config.generated");return config_generated_1=()=>tmp,tmp},events=()=>{var tmp=require("../../aws-events");return events=()=>tmp,tmp},iam=()=>{var tmp=require("../../aws-iam");return iam=()=>tmp,tmp},core_1=()=>{var tmp=require("../../core");return core_1=()=>tmp,tmp};class EvaluationMode{constructor(modes){this.modes=modes}}exports.EvaluationMode=EvaluationMode,_a=JSII_RTTI_SYMBOL_1,EvaluationMode[_a]={fqn:"aws-cdk-lib.aws_config.EvaluationMode",version:"2.147.2"},EvaluationMode.DETECTIVE=new EvaluationMode(["DETECTIVE"]),EvaluationMode.PROACTIVE=new EvaluationMode(["PROACTIVE"]),EvaluationMode.DETECTIVE_AND_PROACTIVE=new EvaluationMode(["DETECTIVE","PROACTIVE"]);class RuleBase extends core_1().Resource{onEvent(id,options={}){const rule=new(events()).Rule(this,id,options);return rule.addEventPattern({source:["aws.config"],detail:{configRuleName:[this.configRuleName]}}),rule.addTarget(options.target),rule}onComplianceChange(id,options={}){const rule=this.onEvent(id,options);return rule.addEventPattern({detailType:["Config Rules Compliance Change"]}),rule}onReEvaluationStatus(id,options={}){const rule=this.onEvent(id,options);return rule.addEventPattern({detailType:["Config Rules Re-evaluation Status"]}),rule}}class RuleNew extends RuleBase{static fromConfigRuleName(scope,id,configRuleName){class Import extends RuleBase{constructor(){super(...arguments),this.configRuleName=configRuleName}}return new Import(scope,id)}}class RuleScope{static fromResource(resourceType,resourceId){try{jsiiDeprecationWarnings().aws_cdk_lib_aws_config_ResourceType(resourceType)}catch(error){throw process.env.JSII_DEBUG!=="1"&&error.name==="DeprecationError"&&Error.captureStackTrace(error,this.fromResource),error}return new RuleScope(resourceId,[resourceType])}static fromResources(resourceTypes){return new RuleScope(void 0,resourceTypes)}static fromTag(key,value){return new RuleScope(void 0,void 0,key,value)}constructor(resourceId,resourceTypes,tagKey,tagValue){this.resourceTypes=resourceTypes,this.resourceId=resourceId,this.key=tagKey,this.value=tagValue}}exports.RuleScope=RuleScope,_b=JSII_RTTI_SYMBOL_1,RuleScope[_b]={fqn:"aws-cdk-lib.aws_config.RuleScope",version:"2.147.2"};var MaximumExecutionFrequency;(function(MaximumExecutionFrequency2){MaximumExecutionFrequency2.ONE_HOUR="One_Hour",MaximumExecutionFrequency2.THREE_HOURS="Three_Hours",MaximumExecutionFrequency2.SIX_HOURS="Six_Hours",MaximumExecutionFrequency2.TWELVE_HOURS="Twelve_Hours",MaximumExecutionFrequency2.TWENTY_FOUR_HOURS="TwentyFour_Hours"})(MaximumExecutionFrequency||(exports.MaximumExecutionFrequency=MaximumExecutionFrequency={}));class ManagedRule extends RuleNew{constructor(scope,id,props){super(scope,id,{physicalName:props.configRuleName});try{jsiiDeprecationWarnings().aws_cdk_lib_aws_config_ManagedRuleProps(props)}catch(error){throw process.env.JSII_DEBUG!=="1"&&error.name==="DeprecationError"&&Error.captureStackTrace(error,ManagedRule),error}this.ruleScope=props.ruleScope;const rule=new(config_generated_1()).CfnConfigRule(this,"Resource",{configRuleName:this.physicalName,description:props.description,inputParameters:props.inputParameters,maximumExecutionFrequency:props.maximumExecutionFrequency,scope:core_1().Lazy.any({produce:()=>renderScope(this.ruleScope)}),source:{owner:"AWS",sourceIdentifier:props.identifier},evaluationModes:props.evaluationModes?.modes.map(mode=>({mode}))});this.configRuleName=rule.ref,this.configRuleArn=rule.attrArn,this.configRuleId=rule.attrConfigRuleId,this.configRuleComplianceType=rule.attrComplianceType,this.isManaged=!0}}exports.ManagedRule=ManagedRule,_c=JSII_RTTI_SYMBOL_1,ManagedRule[_c]={fqn:"aws-cdk-lib.aws_config.ManagedRule",version:"2.147.2"};var EventSource;(function(EventSource2){EventSource2.AWS_CONFIG="aws.config"})(EventSource||(EventSource={}));var MessageType;(function(MessageType2){MessageType2.CONFIGURATION_ITEM_CHANGE_NOTIFICATION="ConfigurationItemChangeNotification",MessageType2.OVERSIZED_CONFIGURATION_ITEM_CHANGE_NOTIFICATION="OversizedConfigurationItemChangeNotification",MessageType2.SCHEDULED_NOTIFICATION="ScheduledNotification",MessageType2.CONFIGURATION_SNAPSHOT_DELIVERY_COMPLETED="ConfigurationSnapshotDeliveryCompleted"})(MessageType||(MessageType={}));class CustomRule extends RuleNew{constructor(scope,id,props){super(scope,id,{physicalName:props.configRuleName});try{jsiiDeprecationWarnings().aws_cdk_lib_aws_config_CustomRuleProps(props)}catch(error){throw process.env.JSII_DEBUG!=="1"&&error.name==="DeprecationError"&&Error.captureStackTrace(error,CustomRule),error}if(!props.configurationChanges&&!props.periodic)throw new Error("At least one of `configurationChanges` or `periodic` must be set to true.");const sourceDetails=[];this.ruleScope=props.ruleScope,props.configurationChanges&&(sourceDetails.push({eventSource:EventSource.AWS_CONFIG,messageType:MessageType.CONFIGURATION_ITEM_CHANGE_NOTIFICATION}),sourceDetails.push({eventSource:EventSource.AWS_CONFIG,messageType:MessageType.OVERSIZED_CONFIGURATION_ITEM_CHANGE_NOTIFICATION})),props.periodic&&sourceDetails.push({eventSource:EventSource.AWS_CONFIG,maximumExecutionFrequency:props.maximumExecutionFrequency,messageType:MessageType.SCHEDULED_NOTIFICATION});const customRulePermissionId=`CustomRulePermission${(0,crypto_1().createHash)("sha256").update(JSON.stringify({fnName:props.lambdaFunction.functionName.toString,accountId:core_1().Stack.of(this).resolve(this.env.account),region:core_1().Stack.of(this).resolve(this.env.region)}),"utf8").digest("base64")}`;props.lambdaFunction.permissionsNode.tryFindChild(customRulePermissionId)||props.lambdaFunction.addPermission(customRulePermissionId,{principal:new(iam()).ServicePrincipal("config.amazonaws.com"),sourceAccount:this.env.account}),props.lambdaFunction.role&&props.lambdaFunction.role.addManagedPolicy(iam().ManagedPolicy.fromAwsManagedPolicyName("service-role/AWSConfigRulesExecutionRole")),this.node.addDependency(props.lambdaFunction);const rule=new(config_generated_1()).CfnConfigRule(this,"Resource",{configRuleName:this.physicalName,description:props.description,inputParameters:props.inputParameters,maximumExecutionFrequency:props.maximumExecutionFrequency,scope:core_1().Lazy.any({produce:()=>renderScope(this.ruleScope)}),source:{owner:"CUSTOM_LAMBDA",sourceDetails,sourceIdentifier:props.lambdaFunction.functionArn},evaluationModes:props.evaluationModes?.modes.map(mode=>({mode}))});this.configRuleName=rule.ref,this.configRuleArn=rule.attrArn,this.configRuleId=rule.attrConfigRuleId,this.configRuleComplianceType=rule.attrComplianceType,props.configurationChanges&&(this.isCustomWithChanges=!0)}}exports.CustomRule=CustomRule,_d=JSII_RTTI_SYMBOL_1,CustomRule[_d]={fqn:"aws-cdk-lib.aws_config.CustomRule",version:"2.147.2"};class CustomPolicy extends RuleNew{constructor(scope,id,props){super(scope,id,{physicalName:props.configRuleName});try{jsiiDeprecationWarnings().aws_cdk_lib_aws_config_CustomPolicyProps(props)}catch(error){throw process.env.JSII_DEBUG!=="1"&&error.name==="DeprecationError"&&Error.captureStackTrace(error,CustomPolicy),error}if(!props.policyText||[...props.policyText].length===0)throw new Error("Policy Text cannot be empty.");if([...props.policyText].length>1e4)throw new Error("Policy Text is limited to 10,000 characters or less.");const sourceDetails=[];this.ruleScope=props.ruleScope,sourceDetails.push({eventSource:EventSource.AWS_CONFIG,messageType:MessageType.CONFIGURATION_ITEM_CHANGE_NOTIFICATION}),sourceDetails.push({eventSource:EventSource.AWS_CONFIG,messageType:MessageType.OVERSIZED_CONFIGURATION_ITEM_CHANGE_NOTIFICATION});const rule=new(config_generated_1()).CfnConfigRule(this,"Resource",{configRuleName:this.physicalName,description:props.description,inputParameters:props.inputParameters,scope:core_1().Lazy.any({produce:()=>renderScope(this.ruleScope)}),source:{owner:"CUSTOM_POLICY",sourceDetails,customPolicyDetails:{enableDebugLogDelivery:props.enableDebugLog,policyRuntime:"guard-2.x.x",policyText:props.policyText}},evaluationModes:props.evaluationModes?.modes.map(mode=>({mode}))});this.configRuleName=rule.ref,this.configRuleArn=rule.attrArn,this.configRuleId=rule.attrConfigRuleId,this.configRuleComplianceType=rule.attrComplianceType,this.isCustomWithChanges=!0}}exports.CustomPolicy=CustomPolicy,_e=JSII_RTTI_SYMBOL_1,CustomPolicy[_e]={fqn:"aws-cdk-lib.aws_config.CustomPolicy",version:"2.147.2"};class ManagedRuleIdentifiers{constructor(){}}exports.ManagedRuleIdentifiers=ManagedRuleIdentifiers,_f=JSII_RTTI_SYMBOL_1,ManagedRuleIdentifiers[_f]={fqn:"aws-cdk-lib.aws_config.ManagedRuleIdentifiers",version:"2.147.2"},ManagedRuleIdentifiers.IAM_INLINE_POLICY_BLOCKED_KMS_ACTIONS="IAM_INLINE_POLICY_BLOCKED_KMS_ACTIONS",ManagedRuleIdentifiers.IAM_CUSTOMER_POLICY_BLOCKED_KMS_ACTIONS="IAM_CUSTOMER_POLICY_BLOCKED_KMS_ACTIONS",ManagedRuleIdentifiers.ACCESS_KEYS_ROTATED="ACCESS_KEYS_ROTATED",ManagedRuleIdentifiers.ACCOUNT_PART_OF_ORGANIZATIONS="ACCOUNT_PART_OF_ORGANIZATIONS",ManagedRuleIdentifiers.ACM_CERTIFICATE_EXPIRATION_CHECK="ACM_CERTIFICATE_EXPIRATION_CHECK",ManagedRuleIdentifiers.ALB_DESYNC_MODE_CHECK="ALB_DESYNC_MODE_CHECK",ManagedRuleIdentifiers.ALB_HTTP_DROP_INVALID_HEADER_ENABLED="ALB_HTTP_DROP_INVALID_HEADER_ENABLED",ManagedRuleIdentifiers.ALB_HTTP_TO_HTTPS_REDIRECTION_CHECK="ALB_HTTP_TO_HTTPS_REDIRECTION_CHECK",ManagedRuleIdentifiers.ALB_WAF_ENABLED="ALB_WAF_ENABLED",ManagedRuleIdentifiers.API_GWV2_ACCESS_LOGS_ENABLED="API_GWV2_ACCESS_LOGS_ENABLED",ManagedRuleIdentifiers.API_GWV2_AUTHORIZATION_TYPE_CONFIGURED="API_GWV2_AUTHORIZATION_TYPE_CONFIGURED",ManagedRuleIdentifiers.API_GW_ASSOCIATED_WITH_WAF="API_GW_ASSOCIATED_WITH_WAF",ManagedRuleIdentifiers.API_GW_CACHE_ENABLED_AND_ENCRYPTED="API_GW_CACHE_ENABLED_AND_ENCRYPTED",ManagedRuleIdentifiers.API_GW_ENDPOINT_TYPE_CHECK="API_GW_ENDPOINT_TYPE_CHECK",ManagedRuleIdentifiers.API_GW_EXECUTION_LOGGING_ENABLED="API_GW_EXECUTION_LOGGING_ENABLED",ManagedRuleIdentifiers.API_GW_SSL_ENABLED="API_GW_SSL_ENABLED",ManagedRuleIdentifiers.API_GW_XRAY_ENABLED="API_GW_XRAY_ENABLED",ManagedRuleIdentifiers.APPROVED_AMIS_BY_ID="APPROVED_AMIS_BY_ID",ManagedRuleIdentifiers.APPROVED_AMIS_BY_TAG="APPROVED_AMIS_BY_TAG",ManagedRuleIdentifiers.AURORA_LAST_BACKUP_RECOVERY_POINT_CREATED="AURORA_LAST_BACKUP_RECOVERY_POINT_CREATED",ManagedRuleIdentifiers.AURORA_MYSQL_BACKTRACKING_ENABLED="AURORA_MYSQL_BACKTRACKING_ENABLED",ManagedRuleIdentifiers.AURORA_RESOURCES_PROTECTED_BY_BACKUP_PLAN="AURORA_RESOURCES_PROTECTED_BY_BACKUP_PLAN",ManagedRuleIdentifiers.AUTOSCALING_CAPACITY_REBALANCING="AUTOSCALING_CAPACITY_REBALANCING",ManagedRuleIdentifiers.AUTOSCALING_GROUP_ELB_HEALTHCHECK_REQUIRED="AUTOSCALING_GROUP_ELB_HEALTHCHECK_REQUIRED",ManagedRuleIdentifiers.AUTOSCALING_LAUNCHCONFIG_REQUIRES_IMDSV2="AUTOSCALING_LAUNCHCONFIG_REQUIRES_IMDSV2",ManagedRuleIdentifiers.AUTOSCALING_LAUNCH_CONFIG_HOP_LIMIT="AUTOSCALING_LAUNCH_CONFIG_HOP_LIMIT",ManagedRuleIdentifiers.AUTOSCALING_LAUNCH_CONFIG_PUBLIC_IP_DISABLED="AUTOSCALING_LAUNCH_CONFIG_PUBLIC_IP_DISABLED",ManagedRuleIdentifiers.AUTOSCALING_LAUNCH_TEMPLATE="AUTOSCALING_LAUNCH_TEMPLATE",ManagedRuleIdentifiers.AUTOSCALING_MULTIPLE_AZ="AUTOSCALING_MULTIPLE_AZ",ManagedRuleIdentifiers.AUTOSCALING_MULTIPLE_INSTANCE_TYPES="AUTOSCALING_MULTIPLE_INSTANCE_TYPES",ManagedRuleIdentifiers.BACKUP_PLAN_MIN_FREQUENCY_AND_MIN_RETENTION_CHECK="BACKUP_PLAN_MIN_FREQUENCY_AND_MIN_RETENTION_CHECK",ManagedRuleIdentifiers.BACKUP_RECOVERY_POINT_ENCRYPTED="BACKUP_RECOVERY_POINT_ENCRYPTED",ManagedRuleIdentifiers.BACKUP_RECOVERY_POINT_MANUAL_DELETION_DISABLED="BACKUP_RECOVERY_POINT_MANUAL_DELETION_DISABLED",ManagedRuleIdentifiers.BACKUP_RECOVERY_POINT_MINIMUM_RETENTION_CHECK="BACKUP_RECOVERY_POINT_MINIMUM_RETENTION_CHECK",ManagedRuleIdentifiers.BEANSTALK_ENHANCED_HEALTH_REPORTING_ENABLED="BEANSTALK_ENHANCED_HEALTH_REPORTING_ENABLED",ManagedRuleIdentifiers.CLB_DESYNC_MODE_CHECK="CLB_DESYNC_MODE_CHECK",ManagedRuleIdentifiers.CLB_MULTIPLE_AZ="CLB_MULTIPLE_AZ",ManagedRuleIdentifiers.CLOUDFORMATION_STACK_DRIFT_DETECTION_CHECK="CLOUDFORMATION_STACK_DRIFT_DETECTION_CHECK",ManagedRuleIdentifiers.CLOUDFORMATION_STACK_NOTIFICATION_CHECK="CLOUDFORMATION_STACK_NOTIFICATION_CHECK",ManagedRuleIdentifiers.CLOUDFRONT_ACCESSLOGS_ENABLED="CLOUDFRONT_ACCESSLOGS_ENABLED",ManagedRuleIdentifiers.CLOUDFRONT_ASSOCIATED_WITH_WAF="CLOUDFRONT_ASSOCIATED_WITH_WAF",ManagedRuleIdentifiers.CLOUDFRONT_CUSTOM_SSL_CERTIFICATE="CLOUDFRONT_CUSTOM_SSL_CERTIFICATE",ManagedRuleIdentifiers.CLOUDFRONT_DEFAULT_ROOT_OBJECT_CONFIGURED="CLOUDFRONT_DEFAULT_ROOT_OBJECT_CONFIGURED",ManagedRuleIdentifiers.CLOUDFRONT_NO_DEPRECATED_SSL_PROTOCOLS="CLOUDFRONT_NO_DEPRECATED_SSL_PROTOCOLS",ManagedRuleIdentifiers.CLOUDFRONT_ORIGIN_ACCESS_IDENTITY_ENABLED="CLOUDFRONT_ORIGIN_ACCESS_IDENTITY_ENABLED",ManagedRuleIdentifiers.CLOUDFRONT_ORIGIN_FAILOVER_ENABLED="CLOUDFRONT_ORIGIN_FAILOVER_ENABLED",ManagedRuleIdentifiers.CLOUDFRONT_SECURITY_POLICY_CHECK="CLOUDFRONT_SECURITY_POLICY_CHECK",ManagedRuleIdentifiers.CLOUDFRONT_SNI_ENABLED="CLOUDFRONT_SNI_ENABLED",ManagedRuleIdentifiers.CLOUDFRONT_TRAFFIC_TO_ORIGIN_ENCRYPTED="CLOUDFRONT_TRAFFIC_TO_ORIGIN_ENCRYPTED",ManagedRuleIdentifiers.CLOUDFRONT_VIEWER_POLICY_HTTPS="CLOUDFRONT_VIEWER_POLICY_HTTPS",ManagedRuleIdentifiers.CLOUD_TRAIL_CLOUD_WATCH_LOGS_ENABLED="CLOUD_TRAIL_CLOUD_WATCH_LOGS_ENABLED",ManagedRuleIdentifiers.CLOUD_TRAIL_ENABLED="CLOUD_TRAIL_ENABLED",ManagedRuleIdentifiers.CLOUD_TRAIL_ENCRYPTION_ENABLED="CLOUD_TRAIL_ENCRYPTION_ENABLED",ManagedRuleIdentifiers.CLOUD_TRAIL_LOG_FILE_VALIDATION_ENABLED="CLOUD_TRAIL_LOG_FILE_VALIDATION_ENABLED",ManagedRuleIdentifiers.CLOUDTRAIL_S3_DATAEVENTS_ENABLED="CLOUDTRAIL_S3_DATAEVENTS_ENABLED",ManagedRuleIdentifiers.CLOUDTRAIL_SECURITY_TRAIL_ENABLED="CLOUDTRAIL_SECURITY_TRAIL_ENABLED",ManagedRuleIdentifiers.CLOUDWATCH_ALARM_ACTION_CHECK="CLOUDWATCH_ALARM_ACTION_CHECK",ManagedRuleIdentifiers.CLOUDWATCH_ALARM_ACTION_ENABLED_CHECK="CLOUDWATCH_ALARM_ACTION_ENABLED_CHECK",ManagedRuleIdentifiers.CLOUDWATCH_ALARM_RESOURCE_CHECK="CLOUDWATCH_ALARM_RESOURCE_CHECK",ManagedRuleIdentifiers.CLOUDWATCH_ALARM_SETTINGS_CHECK="CLOUDWATCH_ALARM_SETTINGS_CHECK",ManagedRuleIdentifiers.CLOUDWATCH_LOG_GROUP_ENCRYPTED="CLOUDWATCH_LOG_GROUP_ENCRYPTED",ManagedRuleIdentifiers.CMK_BACKING_KEY_ROTATION_ENABLED="CMK_BACKING_KEY_ROTATION_ENABLED",ManagedRuleIdentifiers.CODEBUILD_PROJECT_ARTIFACT_ENCRYPTION="CODEBUILD_PROJECT_ARTIFACT_ENCRYPTION",ManagedRuleIdentifiers.CODEBUILD_PROJECT_ENVIRONMENT_PRIVILEGED_CHECK="CODEBUILD_PROJECT_ENVIRONMENT_PRIVILEGED_CHECK",ManagedRuleIdentifiers.CODEBUILD_PROJECT_ENVVAR_AWSCRED_CHECK="CODEBUILD_PROJECT_ENVVAR_AWSCRED_CHECK",ManagedRuleIdentifiers.CODEBUILD_PROJECT_LOGGING_ENABLED="CODEBUILD_PROJECT_LOGGING_ENABLED",ManagedRuleIdentifiers.CODEBUILD_PROJECT_S3_LOGS_ENCRYPTED="CODEBUILD_PROJECT_S3_LOGS_ENCRYPTED",ManagedRuleIdentifiers.CODEBUILD_PROJECT_SOURCE_REPO_URL_CHECK="CODEBUILD_PROJECT_SOURCE_REPO_URL_CHECK",ManagedRuleIdentifiers.CODEDEPLOY_AUTO_ROLLBACK_MONITOR_ENABLED="CODEDEPLOY_AUTO_ROLLBACK_MONITOR_ENABLED",ManagedRuleIdentifiers.CODEDEPLOY_EC2_MINIMUM_HEALTHY_HOSTS_CONFIGURED="CODEDEPLOY_EC2_MINIMUM_HEALTHY_HOSTS_CONFIGURED",ManagedRuleIdentifiers.CODEDEPLOY_LAMBDA_ALLATONCE_TRAFFIC_SHIFT_DISABLED="CODEDEPLOY_LAMBDA_ALLATONCE_TRAFFIC_SHIFT_DISABLED",ManagedRuleIdentifiers.CODEPIPELINE_DEPLOYMENT_COUNT_CHECK="CODEPIPELINE_DEPLOYMENT_COUNT_CHECK",ManagedRuleIdentifiers.CODEPIPELINE_REGION_FANOUT_CHECK="CODEPIPELINE_REGION_FANOUT_CHECK",ManagedRuleIdentifiers.CW_LOGGROUP_RETENTION_PERIOD_CHECK="CW_LOGGROUP_RETENTION_PERIOD_CHECK",ManagedRuleIdentifiers.DAX_ENCRYPTION_ENABLED="DAX_ENCRYPTION_ENABLED",ManagedRuleIdentifiers.RDS_DB_INSTANCE_BACKUP_ENABLED="DB_INSTANCE_BACKUP_ENABLED",ManagedRuleIdentifiers.EC2_DESIRED_INSTANCE_TENANCY="DESIRED_INSTANCE_TENANCY",ManagedRuleIdentifiers.EC2_DESIRED_INSTANCE_TYPE="DESIRED_INSTANCE_TYPE",ManagedRuleIdentifiers.DMS_REPLICATION_NOT_PUBLIC="DMS_REPLICATION_NOT_PUBLIC",ManagedRuleIdentifiers.DYNAMODB_AUTOSCALING_ENABLED="DYNAMODB_AUTOSCALING_ENABLED",ManagedRuleIdentifiers.DYNAMODB_IN_BACKUP_PLAN="DYNAMODB_IN_BACKUP_PLAN",ManagedRuleIdentifiers.DYNAMODB_LAST_BACKUP_RECOVERY_POINT_CREATED="DYNAMODB_LAST_BACKUP_RECOVERY_POINT_CREATED",ManagedRuleIdentifiers.DYNAMODB_PITR_ENABLED="DYNAMODB_PITR_ENABLED",ManagedRuleIdentifiers.DYNAMODB_RESOURCES_PROTECTED_BY_BACKUP_PLAN="DYNAMODB_RESOURCES_PROTECTED_BY_BACKUP_PLAN",ManagedRuleIdentifiers.DYNAMODB_TABLE_ENCRYPTED_KMS="DYNAMODB_TABLE_ENCRYPTED_KMS",ManagedRuleIdentifiers.DYNAMODB_TABLE_ENCRYPTION_ENABLED="DYNAMODB_TABLE_ENCRYPTION_ENABLED",ManagedRuleIdentifiers.DYNAMODB_THROUGHPUT_LIMIT_CHECK="DYNAMODB_THROUGHPUT_LIMIT_CHECK",ManagedRuleIdentifiers.EBS_IN_BACKUP_PLAN="EBS_IN_BACKUP_PLAN",ManagedRuleIdentifiers.EFS_IN_BACKUP_PLAN="EFS_IN_BACKUP_PLAN",ManagedRuleIdentifiers.EC2_EBS_ENCRYPTION_BY_DEFAULT="EC2_EBS_ENCRYPTION_BY_DEFAULT",ManagedRuleIdentifiers.EBS_OPTIMIZED_INSTANCE="EBS_OPTIMIZED_INSTANCE",ManagedRuleIdentifiers.EBS_RESOURCES_PROTECTED_BY_BACKUP_PLAN="EBS_RESOURCES_PROTECTED_BY_BACKUP_PLAN",ManagedRuleIdentifiers.EBS_SNAPSHOT_PUBLIC_RESTORABLE_CHECK="EBS_SNAPSHOT_PUBLIC_RESTORABLE_CHECK",ManagedRuleIdentifiers.EC2_INSTANCE_DETAILED_MONITORING_ENABLED="EC2_INSTANCE_DETAILED_MONITORING_ENABLED",ManagedRuleIdentifiers.EC2_INSTANCE_MANAGED_BY_SSM="EC2_INSTANCE_MANAGED_BY_SSM",ManagedRuleIdentifiers.EC2_INSTANCE_PROFILE_ATTACHED="EC2_INSTANCE_PROFILE_ATTACHED",ManagedRuleIdentifiers.EC2_INSTANCE_MULTIPLE_ENI_CHECK="EC2_INSTANCE_MULTIPLE_ENI_CHECK",ManagedRuleIdentifiers.EC2_INSTANCE_NO_PUBLIC_IP="EC2_INSTANCE_NO_PUBLIC_IP",ManagedRuleIdentifiers.EC2_LAST_BACKUP_RECOVERY_POINT_CREATED="EC2_LAST_BACKUP_RECOVERY_POINT_CREATED",ManagedRuleIdentifiers.EC2_INSTANCES_IN_VPC="INSTANCES_IN_VPC",ManagedRuleIdentifiers.EC2_MANAGED_INSTANCE_APPLICATIONS_BLOCKED="EC2_MANAGEDINSTANCE_APPLICATIONS_BLACKLISTED",ManagedRuleIdentifiers.EC2_MANAGED_INSTANCE_APPLICATIONS_REQUIRED="EC2_MANAGEDINSTANCE_APPLICATIONS_REQUIRED",ManagedRuleIdentifiers.EC2_MANAGED_INSTANCE_ASSOCIATION_COMPLIANCE_STATUS_CHECK="EC2_MANAGEDINSTANCE_ASSOCIATION_COMPLIANCE_STATUS_CHECK",ManagedRuleIdentifiers.EC2_MANAGED_INSTANCE_INVENTORY_BLOCKED="EC2_MANAGEDINSTANCE_INVENTORY_BLACKLISTED",ManagedRuleIdentifiers.EC2_MANAGED_INSTANCE_PATCH_COMPLIANCE_STATUS_CHECK="EC2_MANAGEDINSTANCE_PATCH_COMPLIANCE_STATUS_CHECK",ManagedRuleIdentifiers.EC2_MANAGED_INSTANCE_PLATFORM_CHECK="EC2_MANAGEDINSTANCE_PLATFORM_CHECK",ManagedRuleIdentifiers.EC2_NO_AMAZON_KEY_PAIR="EC2_NO_AMAZON_KEY_PAIR",ManagedRuleIdentifiers.EC2_PARAVIRTUAL_INSTANCE_CHECK="EC2_PARAVIRTUAL_INSTANCE_CHECK",ManagedRuleIdentifiers.EC2_RESOURCES_PROTECTED_BY_BACKUP_PLAN="EC2_RESOURCES_PROTECTED_BY_BACKUP_PLAN",ManagedRuleIdentifiers.EC2_SECURITY_GROUP_ATTACHED_TO_ENI="EC2_SECURITY_GROUP_ATTACHED_TO_ENI",ManagedRuleIdentifiers.EC2_SECURITY_GROUP_ATTACHED_TO_ENI_PERIODIC="EC2_SECURITY_GROUP_ATTACHED_TO_ENI_PERIODIC",ManagedRuleIdentifiers.EC2_STOPPED_INSTANCE="EC2_STOPPED_INSTANCE",ManagedRuleIdentifiers.EC2_TOKEN_HOP_LIMIT_CHECK="EC2_TOKEN_HOP_LIMIT_CHECK",ManagedRuleIdentifiers.EC2_TRANSIT_GATEWAY_AUTO_VPC_ATTACH_DISABLED="EC2_TRANSIT_GATEWAY_AUTO_VPC_ATTACH_DISABLED",ManagedRuleIdentifiers.EC2_VOLUME_INUSE_CHECK="EC2_VOLUME_INUSE_CHECK",ManagedRuleIdentifiers.ECR_PRIVATE_IMAGE_SCANNING_ENABLED="ECR_PRIVATE_IMAGE_SCANNING_ENABLED",ManagedRuleIdentifiers.ECR_PRIVATE_LIFECYCLE_POLICY_CONFIGURED="ECR_PRIVATE_LIFECYCLE_POLICY_CONFIGURED",ManagedRuleIdentifiers.ECR_PRIVATE_TAG_IMMUTABILITY_ENABLED="ECR_PRIVATE_TAG_IMMUTABILITY_ENABLED",ManagedRuleIdentifiers.ECS_AWSVPC_NETWORKING_ENABLED="ECS_AWSVPC_NETWORKING_ENABLED",ManagedRuleIdentifiers.ECS_CONTAINERS_NONPRIVILEGED="ECS_CONTAINERS_NONPRIVILEGED",ManagedRuleIdentifiers.ECS_CONTAINERS_READONLY_ACCESS="ECS_CONTAINERS_READONLY_ACCESS",ManagedRuleIdentifiers.ECS_CONTAINER_INSIGHTS_ENABLED="ECS_CONTAINER_INSIGHTS_ENABLED",ManagedRuleIdentifiers.ECS_FARGATE_LATEST_PLATFORM_VERSION="ECS_FARGATE_LATEST_PLATFORM_VERSION",ManagedRuleIdentifiers.ECS_NO_ENVIRONMENT_SECRETS="ECS_NO_ENVIRONMENT_SECRETS",ManagedRuleIdentifiers.ECS_TASK_DEFINITION_LOG_CONFIGURATION="ECS_TASK_DEFINITION_LOG_CONFIGURATION",ManagedRuleIdentifiers.ECS_TASK_DEFINITION_MEMORY_HARD_LIMIT="ECS_TASK_DEFINITION_MEMORY_HARD_LIMIT",ManagedRuleIdentifiers.ECS_TASK_DEFINITION_NONROOT_USER="ECS_TASK_DEFINITION_NONROOT_USER",ManagedRuleIdentifiers.ECS_TASK_DEFINITION_PID_MODE_CHECK="ECS_TASK_DEFINITION_PID_MODE_CHECK",ManagedRuleIdentifiers.EC2_VOLUME_IECS_TASK_DEFINITION_USER_FOR_HOST_MODE_CHECKNUSE_CHECK="ECS_TASK_DEFINITION_USER_FOR_HOST_MODE_CHECK",ManagedRuleIdentifiers.EFS_ACCESS_POINT_ENFORCE_ROOT_DIRECTORY="EFS_ACCESS_POINT_ENFORCE_ROOT_DIRECTORY",ManagedRuleIdentifiers.EFS_ACCESS_POINT_ENFORCE_USER_IDENTITY="EFS_ACCESS_POINT_ENFORCE_USER_IDENTITY",ManagedRuleIdentifiers.EFS_ENCRYPTED_CHECK="EFS_ENCRYPTED_CHECK",ManagedRuleIdentifiers.EFS_LAST_BACKUP_RECOVERY_POINT_CREATED="EFS_LAST_BACKUP_RECOVERY_POINT_CREATED",ManagedRuleIdentifiers.EFS_RESOURCES_PROTECTED_BY_BACKUP_PLAN="EFS_RESOURCES_PROTECTED_BY_BACKUP_PLAN",ManagedRuleIdentifiers.EIP_ATTACHED="EIP_ATTACHED",ManagedRuleIdentifiers.ELASTICSEARCH_ENCRYPTED_AT_REST="ELASTICSEARCH_ENCRYPTED_AT_REST",ManagedRuleIdentifiers.ELASTICSEARCH_IN_VPC_ONLY="ELASTICSEARCH_IN_VPC_ONLY",ManagedRuleIdentifiers.ELASTICACHE_REDIS_CLUSTER_AUTOMATIC_BACKUP_CHECK="ELASTICACHE_REDIS_CLUSTER_AUTOMATIC_BACKUP_CHECK",ManagedRuleIdentifiers.EC2_IMDSV2_CHECK="EC2_IMDSV2_CHECK",ManagedRuleIdentifiers.EKS_CLUSTER_OLDEST_SUPPORTED_VERSION="EKS_CLUSTER_OLDEST_SUPPORTED_VERSION",ManagedRuleIdentifiers.EKS_CLUSTER_SUPPORTED_VERSION="EKS_CLUSTER_SUPPORTED_VERSION",ManagedRuleIdentifiers.EKS_ENDPOINT_NO_PUBLIC_ACCESS="EKS_ENDPOINT_NO_PUBLIC_ACCESS",ManagedRuleIdentifiers.EKS_SECRETS_ENCRYPTED="EKS_SECRETS_ENCRYPTED",ManagedRuleIdentifiers.ELASTICSEARCH_NODE_TO_NODE_ENCRYPTION_CHECK="ELASTICSEARCH_NODE_TO_NODE_ENCRYPTION_CHECK",ManagedRuleIdentifiers.ELASTIC_BEANSTALK_MANAGED_UPDATES_ENABLED="ELASTIC_BEANSTALK_MANAGED_UPDATES_ENABLED",ManagedRuleIdentifiers.ELBV2_ACM_CERTIFICATE_REQUIRED="ELBV2_ACM_CERTIFICATE_REQUIRED",ManagedRuleIdentifiers.ELBV2_MULTIPLE_AZ="ELBV2_MULTIPLE_AZ",ManagedRuleIdentifiers.ELB_CROSS_ZONE_LOAD_BALANCING_ENABLED="ELB_CROSS_ZONE_LOAD_BALANCING_ENABLED",ManagedRuleIdentifiers.ELB_TLS_HTTPS_LISTENERS_ONLY="ELB_TLS_HTTPS_LISTENERS_ONLY",ManagedRuleIdentifiers.ELB_ACM_CERTIFICATE_REQUIRED="ELB_ACM_CERTIFICATE_REQUIRED",ManagedRuleIdentifiers.ELB_CUSTOM_SECURITY_POLICY_SSL_CHECK="ELB_CUSTOM_SECURITY_POLICY_SSL_CHECK",ManagedRuleIdentifiers.ELB_DELETION_PROTECTION_ENABLED="ELB_DELETION_PROTECTION_ENABLED",ManagedRuleIdentifiers.ELB_LOGGING_ENABLED="ELB_LOGGING_ENABLED",ManagedRuleIdentifiers.ELB_PREDEFINED_SECURITY_POLICY_SSL_CHECK="ELB_PREDEFINED_SECURITY_POLICY_SSL_CHECK",ManagedRuleIdentifiers.EMR_KERBEROS_ENABLED="EMR_KERBEROS_ENABLED",ManagedRuleIdentifiers.EMR_MASTER_NO_PUBLIC_IP="EMR_MASTER_NO_PUBLIC_IP",ManagedRuleIdentifiers.EBS_ENCRYPTED_VOLUMES="ENCRYPTED_VOLUMES",ManagedRuleIdentifiers.FMS_SECURITY_GROUP_AUDIT_POLICY_CHECK="FMS_SECURITY_GROUP_AUDIT_POLICY_CHECK",ManagedRuleIdentifiers.FMS_SECURITY_GROUP_CONTENT_CHECK="FMS_SECURITY_GROUP_CONTENT_CHECK",ManagedRuleIdentifiers.FMS_SECURITY_GROUP_RESOURCE_ASSOCIATION_CHECK="FMS_SECURITY_GROUP_RESOURCE_ASSOCIATION_CHECK",ManagedRuleIdentifiers.FMS_SHIELD_RESOURCE_POLICY_CHECK="FMS_SHIELD_RESOURCE_POLICY_CHECK",ManagedRuleIdentifiers.FMS_WEBACL_RESOURCE_POLICY_CHECK="FMS_WEBACL_RESOURCE_POLICY_CHECK",ManagedRuleIdentifiers.FMS_WEBACL_RULEGROUP_ASSOCIATION_CHECK="FMS_WEBACL_RULEGROUP_ASSOCIATION_CHECK",ManagedRuleIdentifiers.FSX_LAST_BACKUP_RECOVERY_POINT_CREATED="FSX_LAST_BACKUP_RECOVERY_POINT_CREATED",ManagedRuleIdentifiers.FSX_RESOURCES_PROTECTED_BY_BACKUP_PLAN="FSX_RESOURCES_PROTECTED_BY_BACKUP_PLAN",ManagedRuleIdentifiers.GUARDDUTY_ENABLED_CENTRALIZED="GUARDDUTY_ENABLED_CENTRALIZED",ManagedRuleIdentifiers.GUARDDUTY_NON_ARCHIVED_FINDINGS="GUARDDUTY_NON_ARCHIVED_FINDINGS",ManagedRuleIdentifiers.IAM_NO_INLINE_POLICY_CHECK="IAM_NO_INLINE_POLICY_CHECK",ManagedRuleIdentifiers.IAM_GROUP_HAS_USERS_CHECK="IAM_GROUP_HAS_USERS_CHECK",ManagedRuleIdentifiers.IAM_PASSWORD_POLICY="IAM_PASSWORD_POLICY",ManagedRuleIdentifiers.IAM_POLICY_BLOCKED_CHECK="IAM_POLICY_BLACKLISTED_CHECK",ManagedRuleIdentifiers.IAM_POLICY_IN_USE="IAM_POLICY_IN_USE",ManagedRuleIdentifiers.IAM_POLICY_NO_STATEMENTS_WITH_ADMIN_ACCESS="IAM_POLICY_NO_STATEMENTS_WITH_ADMIN_ACCESS",ManagedRuleIdentifiers.IAM_POLICY_NO_STATEMENTS_WITH_FULL_ACCESS="IAM_POLICY_NO_STATEMENTS_WITH_FULL_ACCESS",ManagedRuleIdentifiers.IAM_ROLE_MANAGED_POLICY_CHECK="IAM_ROLE_MANAGED_POLICY_CHECK",ManagedRuleIdentifiers.IAM_ROOT_ACCESS_KEY_CHECK="IAM_ROOT_ACCESS_KEY_CHECK",ManagedRuleIdentifiers.IAM_USER_GROUP_MEMBERSHIP_CHECK="IAM_USER_GROUP_MEMBERSHIP_CHECK",ManagedRuleIdentifiers.IAM_USER_MFA_ENABLED="IAM_USER_MFA_ENABLED",ManagedRuleIdentifiers.IAM_USER_NO_POLICIES_CHECK="IAM_USER_NO_POLICIES_CHECK",ManagedRuleIdentifiers.IAM_USER_UNUSED_CREDENTIALS_CHECK="IAM_USER_UNUSED_CREDENTIALS_CHECK",ManagedRuleIdentifiers.INTERNET_GATEWAY_AUTHORIZED_VPC_ONLY="INTERNET_GATEWAY_AUTHORIZED_VPC_ONLY",ManagedRuleIdentifiers.KINESIS_STREAM_ENCRYPTED="KINESIS_STREAM_ENCRYPTED",ManagedRuleIdentifiers.KMS_CMK_NOT_SCHEDULED_FOR_DELETION="KMS_CMK_NOT_SCHEDULED_FOR_DELETION",ManagedRuleIdentifiers.LAMBDA_CONCURRENCY_CHECK="LAMBDA_CONCURRENCY_CHECK",ManagedRuleIdentifiers.LAMBDA_DLQ_CHECK="LAMBDA_DLQ_CHECK",ManagedRuleIdentifiers.LAMBDA_FUNCTION_PUBLIC_ACCESS_PROHIBITED="LAMBDA_FUNCTION_PUBLIC_ACCESS_PROHIBITED",ManagedRuleIdentifiers.LAMBDA_FUNCTION_SETTINGS_CHECK="LAMBDA_FUNCTION_SETTINGS_CHECK",ManagedRuleIdentifiers.LAMBDA_INSIDE_VPC="LAMBDA_INSIDE_VPC",ManagedRuleIdentifiers.LAMBDA_VPC_MULTI_AZ_CHECK="LAMBDA_VPC_MULTI_AZ_CHECK",ManagedRuleIdentifiers.MFA_ENABLED_FOR_IAM_CONSOLE_ACCESS="MFA_ENABLED_FOR_IAM_CONSOLE_ACCESS",ManagedRuleIdentifiers.CLOUDTRAIL_MULTI_REGION_ENABLED="MULTI_REGION_CLOUD_TRAIL_ENABLED",ManagedRuleIdentifiers.NACL_NO_UNRESTRICTED_SSH_RDP="NACL_NO_UNRESTRICTED_SSH_RDP",ManagedRuleIdentifiers.NETFW_POLICY_DEFAULT_ACTION_FRAGMENT_PACKETS="NETFW_POLICY_DEFAULT_ACTION_FRAGMENT_PACKETS",ManagedRuleIdentifiers.NETFW_POLICY_DEFAULT_ACTION_FULL_PACKETS="NETFW_POLICY_DEFAULT_ACTION_FULL_PACKETS",ManagedRuleIdentifiers.NETFW_POLICY_RULE_GROUP_ASSOCIATED="NETFW_POLICY_RULE_GROUP_ASSOCIATED",ManagedRuleIdentifiers.NETFW_STATELESS_RULE_GROUP_NOT_EMPTY="NETFW_STATELESS_RULE_GROUP_NOT_EMPTY",ManagedRuleIdentifiers.NLB_CROSS_ZONE_LOAD_BALANCING_ENABLED="NLB_CROSS_ZONE_LOAD_BALANCING_ENABLED",ManagedRuleIdentifiers.OPENSEARCH_ACCESS_CONTROL_ENABLED="OPENSEARCH_ACCESS_CONTROL_ENABLED",ManagedRuleIdentifiers.OPENSEARCH_AUDIT_LOGGING_ENABLED="OPENSEARCH_AUDIT_LOGGING_ENABLED",ManagedRuleIdentifiers.OPENSEARCH_DATA_NODE_FAULT_TOLERANCE="OPENSEARCH_DATA_NODE_FAULT_TOLERANCE",ManagedRuleIdentifiers.OPENSEARCH_ENCRYPTED_AT_REST="OPENSEARCH_ENCRYPTED_AT_REST",ManagedRuleIdentifiers.OPENSEARCH_HTTPS_REQUIRED="OPENSEARCH_HTTPS_REQUIRED",ManagedRuleIdentifiers.OPENSEARCH_IN_VPC_ONLY="OPENSEARCH_IN_VPC_ONLY",ManagedRuleIdentifiers.OPENSEARCH_LOGS_TO_CLOUDWATCH="OPENSEARCH_LOGS_TO_CLOUDWATCH",ManagedRuleIdentifiers.OPENSEARCH_NODE_TO_NODE_ENCRYPTION_CHECK="OPENSEARCH_NODE_TO_NODE_ENCRYPTION_CHECK",ManagedRuleIdentifiers.RDS_AUTOMATIC_MINOR_VERSION_UPGRADE_ENABLED="RDS_AUTOMATIC_MINOR_VERSION_UPGRADE_ENABLED",ManagedRuleIdentifiers.RDS_CLUSTER_DEFAULT_ADMIN_CHECK="RDS_CLUSTER_DEFAULT_ADMIN_CHECK",ManagedRuleIdentifiers.RDS_CLUSTER_DELETION_PROTECTION_ENABLED="RDS_CLUSTER_DELETION_PROTECTION_ENABLED",ManagedRuleIdentifiers.RDS_CLUSTER_IAM_AUTHENTICATION_ENABLED="RDS_CLUSTER_IAM_AUTHENTICATION_ENABLED",ManagedRuleIdentifiers.RDS_CLUSTER_MULTI_AZ_ENABLED="RDS_CLUSTER_MULTI_AZ_ENABLED",ManagedRuleIdentifiers.RDS_INSTANCE_DEFAULT_ADMIN_CHECK="RDS_INSTANCE_DEFAULT_ADMIN_CHECK",ManagedRuleIdentifiers.RDS_DB_SECURITY_GROUP_NOT_ALLOWED="RDS_DB_SECURITY_GROUP_NOT_ALLOWED",ManagedRuleIdentifiers.RDS_INSTANCE_DELETION_PROTECTION_ENABLED="RDS_INSTANCE_DELETION_PROTECTION_ENABLED",ManagedRuleIdentifiers.RDS_INSTANCE_IAM_AUTHENTICATION_ENABLED="RDS_INSTANCE_IAM_AUTHENTICATION_ENABLED",ManagedRuleIdentifiers.RDS_LOGGING_ENABLED="RDS_LOGGING_ENABLED",ManagedRuleIdentifiers.REDSHIFT_BACKUP_ENABLED="REDSHIFT_BACKUP_ENABLED",ManagedRuleIdentifiers.RDS_ENHANCED_MONITORING_ENABLED="RDS_ENHANCED_MONITORING_ENABLED",ManagedRuleIdentifiers.RDS_SNAPSHOT_ENCRYPTED="RDS_SNAPSHOT_ENCRYPTED",ManagedRuleIdentifiers.REDSHIFT_REQUIRE_TLS_SSL="REDSHIFT_REQUIRE_TLS_SSL",ManagedRuleIdentifiers.RDS_IN_BACKUP_PLAN="RDS_IN_BACKUP_PLAN",ManagedRuleIdentifiers.RDS_LAST_BACKUP_RECOVERY_POINT_CREATED="RDS_LAST_BACKUP_RECOVERY_POINT_CREATED",ManagedRuleIdentifiers.RDS_INSTANCE_PUBLIC_ACCESS_CHECK="RDS_INSTANCE_PUBLIC_ACCESS_CHECK",ManagedRuleIdentifiers.RDS_MULTI_AZ_SUPPORT="RDS_MULTI_AZ_SUPPORT",ManagedRuleIdentifiers.RDS_RESOURCES_PROTECTED_BY_BACKUP_PLAN="RDS_RESOURCES_PROTECTED_BY_BACKUP_PLAN",ManagedRuleIdentifiers.RDS_SNAPSHOTS_PUBLIC_PROHIBITED="RDS_SNAPSHOTS_PUBLIC_PROHIBITED",ManagedRuleIdentifiers.RDS_STORAGE_ENCRYPTED="RDS_STORAGE_ENCRYPTED",ManagedRuleIdentifiers.REDSHIFT_AUDIT_LOGGING_ENABLED="REDSHIFT_AUDIT_LOGGING_ENABLED",ManagedRuleIdentifiers.REDSHIFT_CLUSTER_CONFIGURATION_CHECK="REDSHIFT_CLUSTER_CONFIGURATION_CHECK",ManagedRuleIdentifiers.REDSHIFT_CLUSTER_KMS_ENABLED="REDSHIFT_CLUSTER_KMS_ENABLED",ManagedRuleIdentifiers.REDSHIFT_CLUSTER_MAINTENANCE_SETTINGS_CHECK="REDSHIFT_CLUSTER_MAINTENANCESETTINGS_CHECK",ManagedRuleIdentifiers.REDSHIFT_CLUSTER_PUBLIC_ACCESS_CHECK="REDSHIFT_CLUSTER_PUBLIC_ACCESS_CHECK",ManagedRuleIdentifiers.REDSHIFT_DEFAULT_ADMIN_CHECK="REDSHIFT_DEFAULT_ADMIN_CHECK",ManagedRuleIdentifiers.REDSHIFT_DEFAULT_DB_NAME_CHECK="REDSHIFT_DEFAULT_DB_NAME_CHECK",ManagedRuleIdentifiers.REDSHIFT_ENHANCED_VPC_ROUTING_ENABLED="REDSHIFT_ENHANCED_VPC_ROUTING_ENABLED",ManagedRuleIdentifiers.REQUIRED_TAGS="REQUIRED_TAGS",ManagedRuleIdentifiers.EC2_SECURITY_GROUPS_RESTRICTED_INCOMING_TRAFFIC="RESTRICTED_INCOMING_TRAFFIC",ManagedRuleIdentifiers.EC2_SECURITY_GROUPS_INCOMING_SSH_DISABLED="INCOMING_SSH_DISABLED",ManagedRuleIdentifiers.ROOT_ACCOUNT_HARDWARE_MFA_ENABLED="ROOT_ACCOUNT_HARDWARE_MFA_ENABLED",ManagedRuleIdentifiers.ROOT_ACCOUNT_MFA_ENABLED="ROOT_ACCOUNT_MFA_ENABLED",ManagedRuleIdentifiers.S3_BUCKET_DEFAULT_LOCK_ENABLED="S3_BUCKET_DEFAULT_LOCK_ENABLED",ManagedRuleIdentifiers.S3_DEFAULT_ENCRYPTION_KMS="S3_DEFAULT_ENCRYPTION_KMS",ManagedRuleIdentifiers.SECURITYHUB_ENABLED="SECURITYHUB_ENABLED",ManagedRuleIdentifiers.SNS_ENCRYPTED_KMS="SNS_ENCRYPTED_KMS",ManagedRuleIdentifiers.SNS_TOPIC_MESSAGE_DELIVERY_NOTIFICATION_ENABLED="SNS_TOPIC_MESSAGE_DELIVERY_NOTIFICATION_ENABLED",ManagedRuleIdentifiers.SSM_DOCUMENT_NOT_PUBLIC="SSM_DOCUMENT_NOT_PUBLIC",ManagedRuleIdentifiers.STORAGEGATEWAY_LAST_BACKUP_RECOVERY_POINT_CREATED="STORAGEGATEWAY_LAST_BACKUP_RECOVERY_POINT_CREATED",ManagedRuleIdentifiers.SUBNET_AUTO_ASSIGN_PUBLIC_IP_DISABLED="SUBNET_AUTO_ASSIGN_PUBLIC_IP_DISABLED",ManagedRuleIdentifiers.S3_ACCOUNT_LEVEL_PUBLIC_ACCESS_BLOCKS="S3_ACCOUNT_LEVEL_PUBLIC_ACCESS_BLOCKS",ManagedRuleIdentifiers.S3_ACCOUNT_LEVEL_PUBLIC_ACCESS_BLOCKS_PERIODIC="S3_ACCOUNT_LEVEL_PUBLIC_ACCESS_BLOCKS_PERIODIC",ManagedRuleIdentifiers.S3_BUCKET_ACL_PROHIBITED="S3_BUCKET_ACL_PROHIBITED",ManagedRuleIdentifiers.S3_BUCKET_BLOCKED_ACTIONS_PROHIBITED="S3_BUCKET_BLACKLISTED_ACTIONS_PROHIBITED",ManagedRuleIdentifiers.S3_BUCKET_LEVEL_PUBLIC_ACCESS_PROHIBITED="S3_BUCKET_LEVEL_PUBLIC_ACCESS_PROHIBITED",ManagedRuleIdentifiers.S3_BUCKET_LOGGING_ENABLED="S3_BUCKET_LOGGING_ENABLED",ManagedRuleIdentifiers.S3_BUCKET_POLICY_GRANTEE_CHECK="S3_BUCKET_POLICY_GRANTEE_CHECK",ManagedRuleIdentifiers.S3_BUCKET_POLICY_NOT_MORE_PERMISSIVE="S3_BUCKET_POLICY_NOT_MORE_PERMISSIVE",ManagedRuleIdentifiers.S3_BUCKET_PUBLIC_READ_PROHIBITED="S3_BUCKET_PUBLIC_READ_PROHIBITED",ManagedRuleIdentifiers.S3_BUCKET_PUBLIC_WRITE_PROHIBITED="S3_BUCKET_PUBLIC_WRITE_PROHIBITED",ManagedRuleIdentifiers.S3_BUCKET_REPLICATION_ENABLED="S3_BUCKET_REPLICATION_ENABLED",ManagedRuleIdentifiers.S3_BUCKET_SERVER_SIDE_ENCRYPTION_ENABLED="S3_BUCKET_SERVER_SIDE_ENCRYPTION_ENABLED",ManagedRuleIdentifiers.S3_BUCKET_SSL_REQUESTS_ONLY="S3_BUCKET_SSL_REQUESTS_ONLY",ManagedRuleIdentifiers.S3_BUCKET_VERSIONING_ENABLED="S3_BUCKET_VERSIONING_ENABLED",ManagedRuleIdentifiers.S3_EVENT_NOTIFICATIONS_ENABLED="S3_EVENT_NOTIFICATIONS_ENABLED",ManagedRuleIdentifiers.S3_LAST_BACKUP_RECOVERY_POINT_CREATED="S3_LAST_BACKUP_RECOVERY_POINT_CREATED",ManagedRuleIdentifiers.S3_LIFECYCLE_POLICY_CHECK="S3_LIFECYCLE_POLICY_CHECK",ManagedRuleIdentifiers.S3_RESOURCES_PROTECTED_BY_BACKUP_PLAN="S3_RESOURCES_PROTECTED_BY_BACKUP_PLAN",ManagedRuleIdentifiers.S3_VERSION_LIFECYCLE_POLICY_CHECK="S3_VERSION_LIFECYCLE_POLICY_CHECK",ManagedRuleIdentifiers.SAGEMAKER_ENDPOINT_CONFIGURATION_KMS_KEY_CONFIGURED="SAGEMAKER_ENDPOINT_CONFIGURATION_KMS_KEY_CONFIGURED",ManagedRuleIdentifiers.SAGEMAKER_NOTEBOOK_INSTANCE_KMS_KEY_CONFIGURED="SAGEMAKER_NOTEBOOK_INSTANCE_KMS_KEY_CONFIGURED",ManagedRuleIdentifiers.SAGEMAKER_NOTEBOOK_NO_DIRECT_INTERNET_ACCESS="SAGEMAKER_NOTEBOOK_NO_DIRECT_INTERNET_ACCESS",ManagedRuleIdentifiers.SECRETSMANAGER_ROTATION_ENABLED_CHECK="SECRETSMANAGER_ROTATION_ENABLED_CHECK",ManagedRuleIdentifiers.SECRETSMANAGER_SCHEDULED_ROTATION_SUCCESS_CHECK="SECRETSMANAGER_SCHEDULED_ROTATION_SUCCESS_CHECK",ManagedRuleIdentifiers.SECRETSMANAGER_SECRET_PERIODIC_ROTATION="SECRETSMANAGER_SECRET_PERIODIC_ROTATION",ManagedRuleIdentifiers.SECRETSMANAGER_SECRET_UNUSED="SECRETSMANAGER_SECRET_UNUSED",ManagedRuleIdentifiers.SECRETSMANAGER_USING_CMK="SECRETSMANAGER_USING_CMK",ManagedRuleIdentifiers.SERVICE_VPC_ENDPOINT_ENABLED="SERVICE_VPC_ENDPOINT_ENABLED",ManagedRuleIdentifiers.SHIELD_ADVANCED_ENABLED_AUTO_RENEW="SHIELD_ADVANCED_ENABLED_AUTORENEW",ManagedRuleIdentifiers.SHIELD_DRT_ACCESS="SHIELD_DRT_ACCESS",ManagedRuleIdentifiers.VIRTUALMACHINE_LAST_BACKUP_RECOVERY_POINT_CREATED="VIRTUALMACHINE_LAST_BACKUP_RECOVERY_POINT_CREATED",ManagedRuleIdentifiers.VIRTUALMACHINE_RESOURCES_PROTECTED_BY_BACKUP_PLAN="VIRTUALMACHINE_RESOURCES_PROTECTED_BY_BACKUP_PLAN",ManagedRuleIdentifiers.VPC_DEFAULT_SECURITY_GROUP_CLOSED="VPC_DEFAULT_SECURITY_GROUP_CLOSED",ManagedRuleIdentifiers.VPC_FLOW_LOGS_ENABLED="VPC_FLOW_LOGS_ENABLED",ManagedRuleIdentifiers.VPC_NETWORK_ACL_UNUSED_CHECK="VPC_NETWORK_ACL_UNUSED_CHECK",ManagedRuleIdentifiers.VPC_PEERING_DNS_RESOLUTION_CHECK="VPC_PEERING_DNS_RESOLUTION_CHECK",ManagedRuleIdentifiers.VPC_SG_OPEN_ONLY_TO_AUTHORIZED_PORTS="VPC_SG_OPEN_ONLY_TO_AUTHORIZED_PORTS",ManagedRuleIdentifiers.VPC_VPN_2_TUNNELS_UP="VPC_VPN_2_TUNNELS_UP",ManagedRuleIdentifiers.WAF_CLASSIC_LOGGING_ENABLED="WAF_CLASSIC_LOGGING_ENABLED",ManagedRuleIdentifiers.WAFV2_LOGGING_ENABLED="WAFV2_LOGGING_ENABLED",ManagedRuleIdentifiers.WAF_GLOBAL_RULEGROUP_NOT_EMPTY="WAF_GLOBAL_RULEGROUP_NOT_EMPTY",ManagedRuleIdentifiers.WAF_GLOBAL_RULE_NOT_EMPTY="WAF_GLOBAL_RULE_NOT_EMPTY",ManagedRuleIdentifiers.WAF_GLOBAL_WEBACL_NOT_EMPTY="WAF_GLOBAL_WEBACL_NOT_EMPTY",ManagedRuleIdentifiers.WAF_REGIONAL_RULEGROUP_NOT_EMPTY="WAF_REGIONAL_RULEGROUP_NOT_EMPTY",ManagedRuleIdentifiers.WAF_REGIONAL_RULE_NOT_EMPTY="WAF_REGIONAL_RULE_NOT_EMPTY",ManagedRuleIdentifiers.WAF_REGIONAL_WEBACL_NOT_EMPTY="WAF_REGIONAL_WEBACL_NOT_EMPTY";class ResourceType{static of(type){return new ResourceType(type)}constructor(type){this.complianceResourceType=type}}exports.ResourceType=ResourceType,_g=JSII_RTTI_SYMBOL_1,ResourceType[_g]={fqn:"aws-cdk-lib.aws_config.ResourceType",version:"2.147.2"},ResourceType.APIGATEWAY_STAGE=new ResourceType("AWS::ApiGateway::Stage"),ResourceType.APIGATEWAYV2_STAGE=new ResourceType("AWS::ApiGatewayV2::Stage"),ResourceType.APIGATEWAY_REST_API=new ResourceType("AWS::ApiGateway::RestApi"),ResourceType.APIGATEWAYV2_API=new ResourceType("AWS::ApiGatewayV2::Api"),ResourceType.CLOUDFRONT_DISTRIBUTION=new ResourceType("AWS::CloudFront::Distribution"),ResourceType.CLOUDFRONT_STREAMING_DISTRIBUTION=new ResourceType("AWS::CloudFront::StreamingDistribution"),ResourceType.CLOUDWATCH_ALARM=new ResourceType("AWS::CloudWatch::Alarm"),ResourceType.CLOUDWATCH_RUM_APP_MONITOR=new ResourceType("AWS::RUM::AppMonitor"),ResourceType.DYNAMODB_TABLE=new ResourceType("AWS::DynamoDB::Table"),ResourceType.EBS_VOLUME=new ResourceType("AWS::EC2::Volume"),ResourceType.EC2_HOST=new ResourceType("AWS::EC2::Host"),ResourceType.EC2_EIP=new ResourceType("AWS::EC2::EIP"),ResourceType.EC2_INSTANCE=new ResourceType("AWS::EC2::Instance"),ResourceType.EC2_NETWORK_INTERFACE=new ResourceType("AWS::EC2::NetworkInterface"),ResourceType.EC2_SECURITY_GROUP=new ResourceType("AWS::EC2::SecurityGroup"),ResourceType.EC2_NAT_GATEWAY=new ResourceType("AWS::EC2::NatGateway"),ResourceType.EC2_EGRESS_ONLY_INTERNET_GATEWAY=new ResourceType("AWS::EC2::EgressOnlyInternetGateway"),ResourceType.EC2_FLOW_LOG=new ResourceType("AWS::EC2::FlowLog"),ResourceType.EC2_TRANSIT_GATEWAY=new ResourceType("AWS::EC2::TransitGateway"),ResourceType.EC2_TRANSIT_GATEWAY_ATTACHMENT=new ResourceType("AWS::EC2::TransitGatewayAttachment"),ResourceType.EC2_TRANSIT_GATEWAY_ROUTE_TABLE=new ResourceType("AWS::EC2::TransitGatewayRouteTable"),ResourceType.EC2_VPC_ENDPOINT=new ResourceType("AWS::EC2::VPCEndpoint"),ResourceType.EC2_VPC_ENDPOINT_SERVICE=new ResourceType("AWS::EC2::VPCEndpointService"),ResourceType.EC2_VPC_PEERING_CONNECTION=new ResourceType("AWS::EC2::VPCPeeringConnection"),ResourceType.EC2_REGISTERED_HA_INSTANCE=new ResourceType("AWS::EC2::RegisteredHAInstance"),ResourceType.EC2_LAUNCH_TEMPLATE=new ResourceType("AWS::EC2::LaunchTemplate"),ResourceType.EC2_NETWORK_INSIGHTS_ACCESS_SCOPE_ANALYSIS=new ResourceType("AWS::EC2::NetworkInsightsAccessScopeAnalysis"),ResourceType.IMAGEBUILDER_CONTAINER_RECIPE=new ResourceType("AWS::ImageBuilder::ContainerRecipe"),ResourceType.IMAGEBUILDER_DISTRIBUTION_CONFIGURATION=new ResourceType("AWS::ImageBuilder::DistributionConfiguration"),ResourceType.IMAGEBUILDER_INFRASTRUCTURE_CONFIGURATION=new ResourceType("AWS::ImageBuilder::InfrastructureConfiguration"),ResourceType.ECR_REPOSITORY=new ResourceType("AWS::ECR::Repository"),ResourceType.ECR_REGISTRY_POLICY=new ResourceType("AWS::ECR::RegistryPolicy"),ResourceType.ECR_PUBLIC_REPOSITORY=new ResourceType("AWS::ECR::PublicRepository"),ResourceType.ECS_CLUSTER=new ResourceType("AWS::ECS::Cluster"),ResourceType.ECS_TASK_DEFINITION=new ResourceType("AWS::ECS::TaskDefinition"),ResourceType.ECS_SERVICE=new ResourceType("AWS::ECS::Service"),ResourceType.EFS_FILE_SYSTEM=new ResourceType("AWS::EFS::FileSystem"),ResourceType.EFS_ACCESS_POINT=new ResourceType("AWS::EFS::AccessPoint"),ResourceType.EKS_CLUSTER=new ResourceType("AWS::EKS::Cluster"),ResourceType.EKS_IDENTITY_PROVIDER_CONFIG=new ResourceType("AWS::EKS::IdentityProviderConfig"),ResourceType.EKS_ADDON=new ResourceType("AWS::EKS::Addon"),ResourceType.EMR_SECURITY_CONFIGURATION=new ResourceType("AWS::EMR::SecurityConfiguration"),ResourceType.EVENTBRIDGE_EVENTBUS=new ResourceType("AWS::Events::EventBus"),ResourceType.EVENTBRIDGE_API_DESTINATION=new ResourceType("AWS::Events::ApiDestination"),ResourceType.EVENTBRIDGE_ARCHIVE=new ResourceType("AWS::Events::Archive"),ResourceType.EVENTBRIDGE_ENDPOINT=new ResourceType("AWS::Events::Endpoint"),ResourceType.EVENTSCHEMAS_REGISTRY=new ResourceType("AWS::EventSchemas::Registry"),ResourceType.EVENTSCHEMAS_REGISTRY_POLICY=new ResourceType("AWS::EventSchemas::RegistryPolicy"),ResourceType.EVENTSCHEMAS_DISCOVERER=new ResourceType("AWS::EventSchemas::Discoverer"),ResourceType.FRAUDDETECTOR_LABEL=new ResourceType("AWS::FraudDetector::Label"),ResourceType.FRAUDDETECTOR_ENTITY_TYPE=new ResourceType("AWS::FraudDetector::EntityType"),ResourceType.FRAUDDETECTOR_VARIABLE=new ResourceType("AWS::FraudDetector::Variable"),ResourceType.FRAUDDETECTOR_OUTCOME=new ResourceType("AWS::FraudDetector::Outcome"),ResourceType.GUARDDUTY_DETECTOR=new ResourceType("AWS::GuardDuty::Detector"),ResourceType.GUARDDUTY_THREAT_INTEL_SET=new ResourceType("AWS::GuardDuty::ThreatIntelSet"),ResourceType.GUARDDUTY_IP_SET=new ResourceType(" AWS::GuardDuty::IPSet"),ResourceType.GUARDDUTY_FILTER=new ResourceType("AWS::GuardDuty::Filter"),ResourceType.ELASTICSEARCH_DOMAIN=new ResourceType("AWS::Elasticsearch::Domain"),ResourceType.IVS_CHANNEL=new ResourceType("AWS::IVS::Channel"),ResourceType.IVS_RECORDING_CONFIGURATION=new ResourceType("AWS::IVS::RecordingConfiguration"),ResourceType.IVS_PLAYBACK_KEYPAIR=new ResourceType("AWS::IVS::PlaybackKeyPair"),ResourceType.OPENSEARCH_DOMAIN=new ResourceType("AWS::OpenSearch::Domain"),ResourceType.QLDB_LEDGER=new ResourceType("AWS::QLDB::Ledger"),ResourceType.KINESIS_STREAM=new ResourceType("AWS::Kinesis::Stream"),ResourceType.KINESIS_STREAM_CONSUMER=new ResourceType("AWS::Kinesis::StreamConsumer"),ResourceType.KINESIS_ANALYTICS_V2_APPLICATION=new ResourceType("AWS::KinesisAnalyticsV2::Application"),ResourceType.LIGHTSAIL_CERTIFICATE=new ResourceType("AWS::Lightsail::Certificate"),ResourceType.LIGHTSAIL_DISK=new ResourceType("AWS::Lightsail::Disk"),ResourceType.LIGHTSAIL_BUCKET=new ResourceType("AWS::Lightsail::Bucket"),ResourceType.LIGHTSAIL_STATIC_IP=new ResourceType("AWS::Lightsail::StaticIp"),ResourceType.AMAZON_MQ_BROKER=new ResourceType("AWS::AmazonMQ::Broker"),ResourceType.MSK_CLUSTER=new ResourceType("AWS::MSK::Cluster"),ResourceType.REDSHIFT_CLUSTER=new ResourceType("AWS::Redshift::Cluster"),ResourceType.REDSHIFT_CLUSTER_PARAMETER_GROUP=new ResourceType("AWS::Redshift::ClusterParameterGroup"),ResourceType.REDSHIFT_CLUSTER_SECURITY_GROUP=new ResourceType("AWS::Redshift::ClusterSecurityGroup"),ResourceType.REDSHIFT_CLUSTER_SNAPSHOT=new ResourceType("AWS::Redshift::ClusterSnapshot"),ResourceType.REDSHIFT_CLUSTER_SUBNET_GROUP=new ResourceType("AWS::Redshift::ClusterSubnetGroup"),ResourceType.REDSHIFT_EVENT_SUBSCRIPTION=new ResourceType("AWS::Redshift::EventSubscription"),ResourceType.RDS_DB_INSTANCE=new ResourceType("AWS::RDS::DBInstance"),ResourceType.RDS_DB_SECURITY_GROUP=new ResourceType("AWS::RDS::DBSecurityGroup"),ResourceType.RDS_DB_SNAPSHOT=new ResourceType("AWS::RDS::DBSnapshot"),ResourceType.RDS_DB_SUBNET_GROUP=new ResourceType("AWS::RDS::DBSubnetGroup"),ResourceType.RDS_EVENT_SUBSCRIPTION=new ResourceType("AWS::RDS::EventSubscription"),ResourceType.RDS_DB_CLUSTER=new ResourceType("AWS::RDS::DBCluster"),ResourceType.RDS_DB_CLUSTER_SNAPSHOT=new ResourceType("AWS::RDS::DBClusterSnapshot"),ResourceType.RDS_GLOBAL_CLUSTER=new ResourceType("AWS::RDS::GlobalCluster"),ResourceType.ROUTE53_HOSTED_ZONE=new ResourceType("AWS::Route53::HostedZone"),ResourceType.ROUTE53_HEALTH_CHECK=new ResourceType("AWS::Route53::HealthCheck"),ResourceType.ROUTE53_RESOLVER_RESOLVER_ENDPOINT=new ResourceType("AWS::Route53Resolver::ResolverEndpoint"),ResourceType.ROUTE53_RESOLVER_RESOLVER_RULE=new ResourceType("AWS::Route53Resolver::ResolverRule"),ResourceType.ROUTE53_RESOLVER_RESOLVER_RULE_ASSOCIATION=new ResourceType("AWS::Route53Resolver::ResolverRuleAssociation"),ResourceType.ROUTE53_RECOVERY_READINESS_CELL=new ResourceType("AWS::Route53RecoveryReadiness::Cell"),ResourceType.ROUTE53_RECOVERY_READINESS_READINESS_CHECK=new ResourceType("AWS::Route53RecoveryReadiness::ReadinessCheck"),ResourceType.ROUTE53_RECOVERY_READINESS_RECOVERY_GROUP=new ResourceType("AWS::Route53RecoveryReadiness::RecoveryGroup"),ResourceType.SQS_QUEUE=new ResourceType("AWS::SQS::Queue"),ResourceType.SNS_TOPIC=new ResourceType("AWS::SNS::Topic"),ResourceType.S3_BUCKET=new ResourceType("AWS::S3::Bucket"),ResourceType.S3_MULTIREGION_ACCESS_POINT=new ResourceType("AWS::S3::MultiRegionAccessPoint"),ResourceType.SAGEMAKER_CODE_REPOSITORY=new ResourceType("AWS::SageMaker::CodeRepository"),ResourceType.SAGEMAKER_MODEL=new ResourceType("AWS::SageMaker::Model"),ResourceType.SAGEMAKER_NOTEBOOK_INSTANCE=new ResourceType("AWS::SageMaker::NotebookInstance"),ResourceType.SAGEMAKER_WORKTEAM=new ResourceType("AWS::SageMaker::Workteam"),ResourceType.SES_CONFIGURATION_SET=new ResourceType("AWS::SES::ConfigurationSet"),ResourceType.SES_CONTACT_LIST=new ResourceType("AWS::SES::ContactList"),ResourceType.SES_TEMPLATE=new ResourceType("AWS::SES::Template"),ResourceType.SES_RECEIPT_FILTER=new ResourceType("AWS::SES::ReceiptFilter"),ResourceType.SES_RECEIPT_RECEIPT_RULE_SET=new ResourceType("AWS::SES::ReceiptRuleSet"),ResourceType.S3_ACCOUNT_PUBLIC_ACCESS_BLOCK=new ResourceType("AWS::S3::AccountPublicAccessBlock"),ResourceType.EC2_CUSTOMER_GATEWAY=new ResourceType("AWS::EC2::CustomerGateway"),ResourceType.EC2_INTERNET_GATEWAY=new ResourceType("AWS::EC2::InternetGateway"),ResourceType.EC2_NETWORK_ACL=new ResourceType("AWS::EC2::NetworkAcl"),ResourceType.EC2_ROUTE_TABLE=new ResourceType("AWS::EC2::RouteTable"),ResourceType.EC2_SUBNET=new ResourceType("AWS::EC2::Subnet"),ResourceType.EC2_VPC=new ResourceType("AWS::EC2::VPC"),ResourceType.EC2_VPN_CONNECTION=new ResourceType("AWS::EC2::VPNConnection"),ResourceType.EC2_VPN_GATEWAY=new ResourceType("AWS::EC2::VPNGateway"),ResourceType.AUTO_SCALING_GROUP=new ResourceType("AWS::AutoScaling::AutoScalingGroup"),ResourceType.AUTO_SCALING_LAUNCH_CONFIGURATION=new ResourceType("AWS::AutoScaling::LaunchConfiguration"),ResourceType.AUTO_SCALING_POLICY=new ResourceType("AWS::AutoScaling::ScalingPolicy"),ResourceType.AUTO_SCALING_SCHEDULED_ACTION=new ResourceType("AWS::AutoScaling::ScheduledAction"),ResourceType.WORKSPACES_CONNECTION_ALIAS=new ResourceType("AWS::WorkSpaces::ConnectionAlias"),ResourceType.WORKSPACES_WORKSPACE=new ResourceType("AWS::WorkSpaces::Workspace"),ResourceType.APPCONFIG_APPLICATION=new ResourceType("AWS::AppConfig::Application"),ResourceType.APPCONFIG_ENVIRONMENT=new ResourceType("AWS::AppConfig::Environment"),ResourceType.APPCONFIG_CONFIGURATION_PROFILE=new ResourceType("AWS::AppConfig::ConfigurationProfile"),ResourceType.APPSYNC_GRAPHQL_API=new ResourceType("AWS::AppSync::GraphQLApi"),ResourceType.BACKUP_BACKUP_PLAN=new ResourceType("AWS::Backup::BackupPlan"),ResourceType.BACKUP_BACKUP_SELECTION=new ResourceType("AWS::Backup::BackupSelection"),ResourceType.BACKUP_BACKUP_VAULT=new ResourceType("AWS::Backup::BackupVault"),ResourceType.BACKUP_RECOVERY_POINT=new ResourceType("AWS::Backup::RecoveryPoint"),ResourceType.BACKUP_REPORT_PLAN=new ResourceType("AWS::Backup::ReportPlan"),ResourceType.BATCH_JOB_QUEUE=new ResourceType("AWS::Batch::JobQueue"),ResourceType.BATCH_COMPUTE_ENVIRONMENT=new ResourceType("AWS::Batch::ComputeEnvironment"),ResourceType.ACM_CERTIFICATE=new ResourceType("AWS::ACM::Certificate"),ResourceType.CLOUDFORMATION_STACK=new ResourceType("AWS::CloudFormation::Stack"),ResourceType.CLOUDTRAIL_TRAIL=new ResourceType("AWS::CloudTrail::Trail"),ResourceType.CLOUD9_ENVIRONMENT_EC2=new ResourceType("AWS::Cloud9::EnvironmentEC2"),ResourceType.SERVICEDISCOVERY_SERVICE=new ResourceType("AWS::ServiceDiscovery::Service"),ResourceType.SERVICEDISCOVERY_PUBLIC_DNS_NAMESPACE=new ResourceType("AWS::ServiceDiscovery::PublicDnsNamespace"),ResourceType.SERVICEDISCOVERY_HTTP_NAMESPACE=new ResourceType("AWS::ServiceDiscovery::HttpNamespace"),ResourceType.CODEBUILD_PROJECT=new ResourceType("AWS::CodeBuild::Project"),ResourceType.CODEDEPLOY_APPLICATION=new ResourceType("AWS::CodeDeploy::Application"),ResourceType.CODEDEPLOY_DEPLOYMENT_CONFIG=new ResourceType("AWS::CodeDeploy::DeploymentConfig"),ResourceType.CODEDEPLOY_DEPLOYMENT_GROUP=new ResourceType("AWS::CodeDeploy::DeploymentGroup"),ResourceType.CODEPIPELINE_PIPELINE=new ResourceType("AWS::CodePipeline::Pipeline"),ResourceType.CONFIG_RESOURCE_COMPLIANCE=new ResourceType("AWS::Config::ResourceCompliance"),ResourceType.CONFIG_CONFORMANCE_PACK_COMPLIANCE=new ResourceType("AWS::Config::ConformancePackCompliance"),ResourceType.DMS_EVENT_SUBSCRIPTION=new ResourceType("AWS::DMS::EventSubscription"),ResourceType.DMS_REPLICATION_SUBNET_GROUP=new ResourceType("AWS::DMS::ReplicationSubnetGroup"),ResourceType.DATASYNC_LOCATION_SMB=new ResourceType("AWS::DataSync::LocationSMB"),ResourceType.DATASYNC_LOCATION_FSX_LUSTRE=new ResourceType("AWS::DataSync::LocationFSxLustre"),ResourceType.DATASYNC_LOCATION_FSX_WINDOWS=new ResourceType("AWS::DataSync::LocationFSxWindows"),ResourceType.DATASYNC_LOCATION_S3=new ResourceType("AWS::DataSync::LocationS3"),ResourceType.DATASYNC_LOCATION_EFS=new ResourceType("AWS::DataSync::LocationEFS"),ResourceType.DATASYNC_TASK=new ResourceType("AWS::DataSync::Task"),ResourceType.DATASYNC_LOCATION_NFS=new ResourceType("AWS::DataSync::LocationNFS"),ResourceType.DATASYNC_LOCATION_OBJECT_STORAGE=new ResourceType("AWS::DataSync::LocationObjectStorage"),ResourceType.DATASYNC_LOCATION_HDFS=new ResourceType("AWS::DataSync::LocationHDFS"),ResourceType.ELASTIC_BEANSTALK_APPLICATION=new ResourceType("AWS::ElasticBeanstalk::Application"),ResourceType.ELASTIC_BEANSTALK_APPLICATION_VERSION=new ResourceType("AWS::ElasticBeanstalk::ApplicationVersion"),ResourceType.ELASTIC_BEANSTALK_ENVIRONMENT=new ResourceType("AWS::ElasticBeanstalk::Environment"),ResourceType.FIS_EXPERIMENT_TEMPLATE=new ResourceType("AWS::FIS::ExperimentTemplate"),ResourceType.GLOBALACCELERATOR_LISTENER=new ResourceType("AWS::GlobalAccelerator::Listener"),ResourceType.GLOBALACCELERATOR_ENDPOINT_GROUP=new ResourceType("AWS::GlobalAccelerator::EndpointGroup"),ResourceType.GLOBALACCELERATOR_ACCELERATOR=new ResourceType("AWS::GlobalAccelerator::Accelerator"),ResourceType.GLUE_JOB=new ResourceType("AWS::Glue::Job"),ResourceType.GLUE_CLASSIFIER=new ResourceType("AWS::Glue::Classifier"),ResourceType.GLUE_ML_TRANSFORM=new ResourceType("AWS::Glue::MLTransform"),ResourceType.IAM_USER=new ResourceType("AWS::IAM::User"),ResourceType.IAM_GROUP=new ResourceType("AWS::IAM::Group"),ResourceType.IAM_ROLE=new ResourceType("AWS::IAM::Role"),ResourceType.IAM_POLICY=new ResourceType("AWS::IAM::Policy"),ResourceType.IAM_ACCESSANALYZER_ANALYZER=new ResourceType("AWS::AccessAnalyzer::Analyzer"),ResourceType.IOT_AUTHORIZER=new ResourceType("AWS::IoT::Authorizer"),ResourceType.IOT_SECURITY_PROFILE=new ResourceType("AWS::IoT::SecurityProfile"),ResourceType.IOT_ROLE_ALIAS=new ResourceType("AWS::IoT::RoleAlias"),ResourceType.IOT_DIMENSION=new ResourceType("AWS::IoT::Dimension"),ResourceType.IOT_POLICY=new ResourceType("AWS::IoT::Policy"),ResourceType.IOT_MITIGATION_ACTION=new ResourceType("AWS::IoT::MitigationAction"),ResourceType.IOT_TWINMAKER_WORKSPACE=new ResourceType("AWS::IoTwinMaker::Workspace"),ResourceType.IOT_TWINMAKER_ENTITY=new ResourceType("AWS::IoTTwinMaker::Entity"),ResourceType.IOT_ANALYTICS_DATASTORE=new ResourceType("AWS::IoTAnalytics::Datastore"),ResourceType.IOT_ANALYTICS_DATASET=new ResourceType("AWS::IoTAnalytics::Dataset"),ResourceType.IOT_ANALYTICS_PIPELINE=new ResourceType("AWS::IoTAnalytics::Pipeline"),ResourceType.IOT_ANALYTICS_CHANNEL=new ResourceType("AWS::IoTAnalytics::Channel"),ResourceType.IOT_EVENTS_INPUT=new ResourceType("AWS::IoTEvents::Input"),ResourceType.IOT_EVENTS_DETECTOR_MODEL=new ResourceType("AWS::IoTEvents::DetectorModel"),ResourceType.IOT_EVENTS_ALARM_MODEL=new ResourceType("AWS::IoTEvents::AlarmModel"),ResourceType.IOT_SITEWISE_DASHBOARD=new ResourceType("AWS::IoTSiteWise::Dashboard"),ResourceType.IOT_SITEWISE_PROJECT=new ResourceType("AWS::IoTSiteWise::Project"),ResourceType.IOT_SITEWISE_PORTAL=new ResourceType("AWS::IoTSiteWise::Portal"),ResourceType.IOT_SITEWISE_ASSETMODEL=new ResourceType("AWS::IoTSiteWise::AssetModel"),ResourceType.KMS_KEY=new ResourceType("AWS::KMS::Key"),ResourceType.LAMBDA_FUNCTION=new ResourceType("AWS::Lambda::Function"),ResourceType.NETWORK_FIREWALL_FIREWALL=new ResourceType("AWS::NetworkFirewall::Firewall"),ResourceType.NETWORK_FIREWALL_FIREWALL_POLICY=new ResourceType("AWS::NetworkFirewall::FirewallPolicy"),ResourceType.NETWORK_FIREWALL_RULE_GROUP=new ResourceType("AWS::NetworkFirewall::RuleGroup"),ResourceType.RESILIENCEHUB_RESILIENCY_POLICY=new ResourceType("AWS::ResilienceHub::ResiliencyPolicy"),ResourceType.SECRETS_MANAGER_SECRET=new ResourceType("AWS::SecretsManager::Secret"),ResourceType.SERVICE_CATALOG_CLOUDFORMATION_PRODUCT=new ResourceType("AWS::ServiceCatalog::CloudFormationProduct"),ResourceType.SERVICE_CATALOG_CLOUDFORMATION_PROVISIONED_PRODUCT=new ResourceType("AWS::ServiceCatalog::CloudFormationProvisionedProduct"),ResourceType.SERVICE_CATALOG_PORTFOLIO=new ResourceType("AWS::ServiceCatalog::Portfolio"),ResourceType.SHIELD_PROTECTION=new ResourceType("AWS::Shield::Protection"),ResourceType.SHIELD_REGIONAL_PROTECTION=new ResourceType("AWS::ShieldRegional::Protection"),ResourceType.STEPFUNCTIONS_ACTIVITY=new ResourceType("AWS::StepFunctions::Activity"),ResourceType.STEPFUNCTIONS_STATE_MACHINE=new ResourceType("AWS::StepFunctions::StateMachine"),ResourceType.SYSTEMS_MANAGER_MANAGED_INSTANCE_INVENTORY=new ResourceType("AWS::SSM::ManagedInstanceInventory"),ResourceType.SYSTEMS_MANAGER_PATCH_COMPLIANCE=new ResourceType("AWS::SSM::PatchCompliance"),ResourceType.SYSTEMS_MANAGER_ASSOCIATION_COMPLIANCE=new ResourceType("AWS::SSM::AssociationCompliance"),ResourceType.SYSTEMS_MANAGER_FILE_DATA=new ResourceType("AWS::SSM::FileData"),ResourceType.TRANSFER_WORKFLOW=new ResourceType("AWS::Transfer::Workflow"),ResourceType.WAF_RATE_BASED_RULE=new ResourceType("AWS::WAF::RateBasedRule"),ResourceType.WAF_RULE=new ResourceType("AWS::WAF::Rule"),ResourceType.WAF_WEB_ACL=new ResourceType("AWS::WAF::WebACL"),ResourceType.WAF_RULE_GROUP=new ResourceType("AWS::WAF::RuleGroup"),ResourceType.WAF_REGIONAL_RATE_BASED_RULE=new ResourceType("AWS::WAFRegional::RateBasedRule"),ResourceType.WAF_REGIONAL_RULE=new ResourceType("AWS::WAFRegional::Rule"),ResourceType.WAF_REGIONAL_WEB_ACL=new ResourceType("AWS::WAFRegional::WebACL"),ResourceType.WAF_REGIONAL_RULE_GROUP=new ResourceType("AWS::WAFRegional::RuleGroup"),ResourceType.WAFV2_WEB_ACL=new ResourceType("AWS::WAFv2::WebACL"),ResourceType.WAFV2_RULE_GROUP=new ResourceType("AWS::WAFv2::RuleGroup"),ResourceType.WAFV2_MANAGED_RULE_SET=new ResourceType("AWS::WAFv2::ManagedRuleSet"),ResourceType.WAFV2_IP_SET=new ResourceType("AWS::WAFv2::IPSet"),ResourceType.WAFV2_REGEX_PATTERN_SET=new ResourceType("AWS::WAFv2::RegexPatternSet"),ResourceType.XRAY_ENCRYPTION_CONFIGURATION=new ResourceType("AWS::XRay::EncryptionConfig"),ResourceType.ELB_LOAD_BALANCER=new ResourceType("AWS::ElasticLoadBalancing::LoadBalancer"),ResourceType.ELBV2_LOAD_BALANCER=new ResourceType("AWS::ElasticLoadBalancingV2::LoadBalancer"),ResourceType.ELBV2_LISTENER=new ResourceType("AWS::ElasticLoadBalancingV2::Listener"),ResourceType.MEDIAPACKAGE_PACKAGING_GROUP=new ResourceType("AWS::MediaPackage::PackagingGroup"),ResourceType.DEVICE_FARM_TEST_GRID_PROJECT=new ResourceType("AWS::DeviceFarm::TestGridProject"),ResourceType.BUDGETS_BUDGETS_ACTION=new ResourceType("AWS::Budgets::BudgetsAction"),ResourceType.LEX_BOT=new ResourceType("AWS::Lex::Bot"),ResourceType.LEX_BOT_ALIAS=new ResourceType("AWS::Lex::BotAlias"),ResourceType.CODE_GURU_REVIEWER_REPOSITORY_ASSOCIATION=new ResourceType("AWS::CodeGuruReviewer::RepositoryAssociation"),ResourceType.IOT_CUSTOM_METRIC=new ResourceType("AWS::IoT::CustomMetric"),ResourceType.IOT_ACCOUNT_AUDIT_CONFIGURATION=new ResourceType("AWS::IoT::AccountAuditConfiguration"),ResourceType.IOT_SCHEDULED_AUDIT=new ResourceType("AWS::IoT::ScheduledAudit"),ResourceType.ROUTE53_RESOLVER_FIREWALL_DOMAIN_LIST=new ResourceType("AWS::Route53Resolver::FirewallDomainList"),ResourceType.ROBO_MAKER_ROBOT_APPLICATION_VERSION=new ResourceType("AWS::RoboMaker::RobotApplicationVersion"),ResourceType.EC2_TRAFFIC_MIRROR_SESSION=new ResourceType("AWS::EC2::TrafficMirrorSession"),ResourceType.EC2_TRAFFIC_MIRROR_TARGET=new ResourceType("AWS::EC2::TrafficMirrorTarget"),ResourceType.IOT_SITEWISE_GATEWAY=new ResourceType("AWS::IoTSiteWise::Gateway"),ResourceType.LOOKOUT_METRICS_ALERT=new ResourceType("AWS::LookoutMetrics::Alert"),ResourceType.S3_STORAGE_LENS=new ResourceType("AWS::S3::StorageLens"),ResourceType.EVENTS_CONNECTION=new ResourceType("AWS::Events::Connection"),ResourceType.EVENT_SCHEMAS_SCHEMA=new ResourceType("AWS::EventSchemas::Schema"),ResourceType.MEDIA_PACKAGE_PACKAGING_CONFIGURATION=new ResourceType("AWS::MediaPackage::PackagingConfiguration"),ResourceType.APP_STREAM_DIRECTORY_CONFIG=new ResourceType("AWS::AppStream::DirectoryConfig"),ResourceType.AUTO_SCALING_WARM_POOL=new ResourceType("AWS::AutoScaling::WarmPool"),ResourceType.CONNECT_PHONE_NUMBER=new ResourceType("AWS::Connect::PhoneNumber"),ResourceType.CUSTOMER_PROFILES_DOMAIN=new ResourceType("AWS::CustomerProfiles::Domain"),ResourceType.EC2_DHCP_OPTIONS=new ResourceType("AWS::EC2::DHCPOptions"),ResourceType.EC2_IPAM=new ResourceType("AWS::EC2::IPAM"),ResourceType.EC2_NETWORK_INSIGHTS_PATH=new ResourceType("AWS::EC2::NetworkInsightsPath"),ResourceType.EC2_TRAFFIC_MIRROR_FILTER=new ResourceType("AWS::EC2::TrafficMirrorFilter"),ResourceType.EVENTS_RULE=new ResourceType("AWS::Events::Rule"),ResourceType.HEALTH_LAKE_FHIR_DATASTORE=new ResourceType("AWS::HealthLake::FHIRDatastore"),ResourceType.IOT_TWIN_MAKER_SCENE=new ResourceType("AWS::IoTTwinMaker::Scene"),ResourceType.KINESIS_VIDEO_SIGNALING_CHANNEL=new ResourceType("AWS::KinesisVideo::SignalingChannel"),ResourceType.LOOKOUT_VISION_PROJECT=new ResourceType("AWS::LookoutVision::Project"),ResourceType.NETWORK_MANAGER_TRANSIT_GATEWAY_REGISTRATION=new ResourceType("AWS::NetworkManager::TransitGatewayRegistration"),ResourceType.PINPOINT_APPLICATION_SETTINGS=new ResourceType("AWS::Pinpoint::ApplicationSettings"),ResourceType.PINPOINT_SEGMENT=new ResourceType("AWS::Pinpoint::Segment"),ResourceType.ROBO_MAKER_ROBOT_APPLICATION=new ResourceType("AWS::RoboMaker::RobotApplication"),ResourceType.ROBO_MAKER_SIMULATION_APPLICATION=new ResourceType("AWS::RoboMaker::SimulationApplication"),ResourceType.ROUTE53_RECOVERY_CONTROL_CLUSTER=new ResourceType("AWS::Route53RecoveryControl::Cluster"),ResourceType.ROUTE53_RECOVERY_CONTROL_CONTROL_PANEL=new ResourceType("AWS::Route53RecoveryControl::ControlPanel"),ResourceType.ROUTE53_RECOVERY_CONTROL_ROUTING_CONTROL=new ResourceType("AWS::Route53RecoveryControl::RoutingControl"),ResourceType.ROUTE53_RECOVERY_CONTROL_SAFETY_RULE=new ResourceType("AWS::Route53RecoveryControl::SafetyRule"),ResourceType.ROUTE53_RECOVERY_READINESS_RESOURCE_SET=new ResourceType("AWS::Route53RecoveryReadiness::ResourceSet"),ResourceType.ROUTE53_RESOLVER_FIREWALL_RULE_GROUP_ASSOCIATION=new ResourceType("AWS::Route53Resolver::FirewallRuleGroupAssociation"),ResourceType.EC2_EC2_FLEET=new ResourceType("AWS::EC2::EC2Fleet"),ResourceType.IOT_WIRELESS_SERVICE_PROFILE=new ResourceType("AWS::IoTWireless::ServiceProfile"),ResourceType.EC2_SUBNET_ROUTE_TABLE_ASSOCIATION=new ResourceType("AWS::EC2::SubnetRouteTableAssociation"),ResourceType.NETWORK_MANAGER_GLOBAL_NETWORK=new ResourceType("AWS::NetworkManager::GlobalNetwork"),ResourceType.DEVICE_FARM_INSTANCE_PROFILE=new ResourceType("AWS::DeviceFarm::InstanceProfile"),ResourceType.GROUND_STATION_CONFIG=new ResourceType("AWS::GroundStation::Config"),ResourceType.APP_FLOW_FLOW=new ResourceType("AWS::AppFlow::Flow"),ResourceType.REDSHIFT_SCHEDULED_ACTION=new ResourceType("AWS::Redshift::ScheduledAction"),ResourceType.PINPOINT_APP=new ResourceType("AWS::Pinpoint::App"),ResourceType.IOT_FLEET_METRIC=new ResourceType("AWS::IoT::FleetMetric"),ResourceType.APP_CONFIG_DEPLOYMENT_STRATEGY=new ResourceType("AWS::AppConfig::DeploymentStrategy"),ResourceType.NETWORK_MANAGER_DEVICE=new ResourceType("AWS::NetworkManager::Device"),ResourceType.IMAGE_BUILDER_IMAGE_PIPELINE=new ResourceType("AWS::ImageBuilder::ImagePipeline"),ResourceType.CLOUD_WATCH_METRIC_STREAM=new ResourceType("AWS::CloudWatch::MetricStream"),ResourceType.PANORAMA_PACKAGE=new ResourceType("AWS::Panorama::Package"),ResourceType.SAGE_MAKER_IMAGE=new ResourceType("AWS::SageMaker::Image"),ResourceType.ECR_PULL_THROUGH_CACHE_RULE=new ResourceType("AWS::ECR::PullThroughCacheRule"),ResourceType.AUDIT_MANAGER_ASSESSMENT=new ResourceType("AWS::AuditManager::Assessment"),ResourceType.NETWORK_MANAGER_SITE=new ResourceType("AWS::NetworkManager::Site"),ResourceType.SAGE_MAKER_APP_IMAGE_CONFIG=new ResourceType("AWS::SageMaker::AppImageConfig"),ResourceType.DEVICE_FARM_PROJECT=new ResourceType("AWS::DeviceFarm::Project"),ResourceType.NETWORK_MANAGER_LINK=new ResourceType("AWS::NetworkManager::Link"),ResourceType.NETWORK_FIREWALL_TLS_INSPECTION_CONFIGURATION=new ResourceType("AWS::NetworkFirewall::TLSInspectionConfiguration"),ResourceType.AMPLIFY_APP=new ResourceType("AWS::Amplify::App"),ResourceType.APP_MESH_VIRTUAL_NODE=new ResourceType("AWS::AppMesh::VirtualNode"),ResourceType.APP_MESH_VIRTUAL_SERVICE=new ResourceType("AWS::AppMesh::VirtualService"),ResourceType.APP_RUNNER_VPC_CONNECTOR=new ResourceType("AWS::AppRunner::VpcConnector"),ResourceType.APP_STREAM_APPLICATION=new ResourceType("AWS::AppStream::Application"),ResourceType.CASSANDRA_KEYSPACE=new ResourceType("AWS::Cassandra::Keyspace"),ResourceType.CODE_ARTIFACT_REPOSITORY=new ResourceType("AWS::CodeArtifact::Repository"),ResourceType.EC2_PREFIX_LIST=new ResourceType("AWS::EC2::PrefixList"),ResourceType.EC2_SPOT_FLEET=new ResourceType("AWS::EC2::SpotFleet"),ResourceType.ECS_TASK_SET=new ResourceType("AWS::ECS::TaskSet"),ResourceType.EVIDENTLY_PROJECT=new ResourceType("AWS::Evidently::Project"),ResourceType.FORECAST_DATASET=new ResourceType("AWS::Forecast::Dataset"),ResourceType.IAM_SAML_PROVIDER=new ResourceType("AWS::IAM::SAMLProvider"),ResourceType.IAM_SERVER_CERTIFICATE=new ResourceType("AWS::IAM::ServerCertificate"),ResourceType.KINESIS_FIREHOSE_DELIVERY_STREAM=new ResourceType("AWS::KinesisFirehose::DeliveryStream"),ResourceType.PINPOINT_CAMPAIGN=new ResourceType("AWS::Pinpoint::Campaign"),ResourceType.PINPOINT_IN_APP_TEMPLATE=new ResourceType("AWS::Pinpoint::InAppTemplate"),ResourceType.SIGNER_SIGNING_PROFILE=new ResourceType("AWS::Signer::SigningProfile"),ResourceType.SAGEMAKER_DOMAIN=new ResourceType("AWS::SageMaker::Domain"),ResourceType.TRANSFER_AGREEMENT=new ResourceType("AWS::Transfer::Agreement"),ResourceType.TRANSFER_CONNECTOR=new ResourceType("AWS::Transfer::Connector"),ResourceType.ACMPCA_CERTIFICATE_AUTHORITY=new ResourceType("AWS::ACMPCA::CertificateAuthority"),ResourceType.APP_CONFIG_HOSTED_CONFIGURATION_VERSION=new ResourceType("AWS::AppConfig::HostedConfigurationVersion"),ResourceType.APP_MESH_VIRTUAL_GATEWAY=new ResourceType("AWS::AppMesh::VirtualGateway"),ResourceType.APP_MESH_VIRTUAL_ROUTER=new ResourceType("AWS::AppMesh::VirtualRouter"),ResourceType.APP_RUNNER_SERVICE=new ResourceType("AWS::AppRunner::Service"),ResourceType.CUSTOMER_PROFILES_OBJECT_TYPE=new ResourceType("AWS::CustomerProfiles::ObjectType"),ResourceType.DMS_ENDPOINT=new ResourceType("AWS::DMS::Endpoint"),ResourceType.EC2_CAPACITY_RESERVATION=new ResourceType("AWS::EC2::CapacityReservation"),ResourceType.EC2_CLIENT_VPN_ENDPOINT=new ResourceType("AWS::EC2::ClientVpnEndpoint"),ResourceType.KENDRA_INDEX=new ResourceType("AWS::Kendra::Index"),ResourceType.KINESIS_VIDEO_STREAM=new ResourceType("AWS::KinesisVideo::Stream"),ResourceType.LOGS_DESTINATION=new ResourceType("AWS::Logs::Destination"),ResourceType.NETWORK_MANAGER_CUSTOMER_GATEWAY_ASSOCIATION=new ResourceType("AWS::NetworkManager::CustomerGatewayAssociation"),ResourceType.NETWORK_MANAGER_LINK_ASSOCIATION=new ResourceType("AWS::NetworkManager::LinkAssociation"),ResourceType.PINPOINT_EMAIL_CHANNEL=new ResourceType("AWS::Pinpoint::EmailChannel"),ResourceType.S3_ACCESS_POINT=new ResourceType("AWS::S3::AccessPoint"),ResourceType.AMPLIFY_BRANCH=new ResourceType("AWS::Amplify::Branch"),ResourceType.APP_INTEGRATIONS_EVENT_INTEGRATION=new ResourceType("AWS::AppIntegrations::EventIntegration"),ResourceType.APP_MESH_ROUTE=new ResourceType("AWS::AppMesh::Route"),ResourceType.ATHENA_PREPARED_STATEMENT=new ResourceType("AWS::Athena::PreparedStatement"),ResourceType.EC2_IPAM_SCOPE=new ResourceType("AWS::EC2::IPAMScope"),ResourceType.EVIDENTLY_LAUNCH=new ResourceType("AWS::Evidently::Launch"),ResourceType.FORECAST_DATASET_GROUP=new ResourceType("AWS::Forecast::DatasetGroup"),ResourceType.GREENGRASSV2_COMPONENT_VERSION=new ResourceType("AWS::GreengrassV2::ComponentVersion"),ResourceType.GROUNDSTATION_MISSION_PROFILE=new ResourceType("AWS::GroundStation::MissionProfile"),ResourceType.MEDIACONNECT_FLOW_ENTITLEMENT=new ResourceType("AWS::MediaConnect::FlowEntitlement"),ResourceType.MEDIACONNECT_FLOW_VPC_INTERFACE=new ResourceType("AWS::MediaConnect::FlowVpcInterface"),ResourceType.MEDIATAILOR_PLAYBACK_CONFIGURATION=new ResourceType("AWS::MediaTailor::PlaybackConfiguration"),ResourceType.MSK_CONFIGURATION=new ResourceType("AWS::MSK::Configuration"),ResourceType.PERSONALIZE_DATASET=new ResourceType("AWS::Personalize::Dataset"),ResourceType.PERSONALIZE_SCHEMA=new ResourceType("AWS::Personalize::Schema"),ResourceType.PERSONALIZE_SOLUTION=new ResourceType("AWS::Personalize::Solution"),ResourceType.PINPOINT_EMAIL_TEMPLATE=new ResourceType("AWS::Pinpoint::EmailTemplate"),ResourceType.PINPOINT_EVENT_STREAM=new ResourceType("AWS::Pinpoint::EventStream"),ResourceType.RESILIENCEHUB_APP=new ResourceType("AWS::ResilienceHub::App"),ResourceType.CODE_GURU_PROFILER_PROFILING_GROUP=new ResourceType("AWS::CodeGuruProfiler::ProfilingGroup"),ResourceType.MEDIA_CONNECT_FLOW_SOURCE=new ResourceType("AWS::MediaConnect::FlowSource"),ResourceType.TRANSFER_CERTIFICATE=new ResourceType("AWS::Transfer::Certificate"),ResourceType.APS_RULE_GROUPS_NAMESPACE=new ResourceType("AWS::APS::RuleGroupsNamespace"),ResourceType.BATCH_SCHEDULING_POLICY=new ResourceType("AWS::Batch::SchedulingPolicy"),ResourceType.SERVICE_DISCOVERY_INSTANCE=new ResourceType("AWS::ServiceDiscovery::Instance"),ResourceType.ROUTE53_RESOLVER_QUERY_LOGGING_CONFIG=new ResourceType("AWS::Route53Resolver::ResolverQueryLoggingConfig"),ResourceType.ROUTE53_RESOLVER_QUERY_LOGGING_CONFIG_ASSOCIATION=new ResourceType("AWS::Route53Resolver::ResolverQueryLoggingConfigAssociation"),ResourceType.IOT_JOB_TEMPLATE=new ResourceType("AWS::IoT::JobTemplate"),ResourceType.IOT_TWIN_MAKER_COMPONENT_TYPE=new ResourceType("AWS::IoTTwinMaker::ComponentType"),ResourceType.IOT_WIRELESS_MULTICAST_GROUP=new ResourceType("AWS::IoTWireless::MulticastGroup"),ResourceType.PERSONALIZE_DATASET_GROUP=new ResourceType("AWS::Personalize::DatasetGroup"),ResourceType.IOT_PROVISIONING_TEMPLATE=new ResourceType("AWS::IoT::ProvisioningTemplate"),ResourceType.IOT_WIRELESS_FUOTA_TASK=new ResourceType("AWS::IoTWireless::FuotaTask"),ResourceType.MSK_BATCH_SCRAM_SECRET=new ResourceType("AWS::MSK::BatchScramSecret"),ResourceType.SAGEMAKER_FEATURE_GROUP=new ResourceType("AWS::SageMaker::FeatureGroup"),ResourceType.CODE_BUILD_REPORT_GROUP=new ResourceType("AWS::CodeBuild::ReportGroup"),ResourceType.APP_STREAM_STACK=new ResourceType("AWS::AppStream::Stack"),ResourceType.INSPECTORV2_FILTER=new ResourceType("AWS::InspectorV2::Filter"),ResourceType.APP_STREAM_FLEET=new ResourceType("AWS::AppStream::Fleet"),ResourceType.GRAFANA_WORKSPACE=new ResourceType("AWS::Grafana::Workspace"),ResourceType.KMS_ALIAS=new ResourceType("AWS::KMS::Alias"),ResourceType.RDS_OPTION_GROUP=new ResourceType("AWS::RDS::OptionGroup"),ResourceType.ROUTE53_RESOLVER_FIREWALL_RULE_GROUP=new ResourceType("AWS::Route53Resolver::FirewallRuleGroup"),ResourceType.IAM_INSTANCE_PROFILE=new ResourceType("AWS::IAM::InstanceProfile"),ResourceType.NETWORK_MANAGER_CONNECT_PEER=new ResourceType("AWS::NetworkManager::ConnectPeer"),ResourceType.ACMPCA_CERTIFICATE_AUTHORITY_ACTIVATION=new ResourceType("AWS::ACMPCA::CertificateAuthorityActivation"),ResourceType.APP_MESH_GATEWAY_ROUTE=new ResourceType("AWS::AppMesh::GatewayRoute"),ResourceType.APP_MESH_MESH=new ResourceType("AWS::AppMesh::Mesh"),ResourceType.CONNECT_QUICK_CONNECT=new ResourceType("AWS::Connect::QuickConnect"),ResourceType.EC2_CARRIER_GATEWAY=new ResourceType("AWS::EC2::CarrierGateway"),ResourceType.EC2_TRANSIT_GATEWAY_CONNECT=new ResourceType("AWS::EC2::TransitGatewayConnect"),ResourceType.ECS_CAPACITY_PROVIDER=new ResourceType("AWS::ECS::CapacityProvider"),ResourceType.IOT_CA_CERTIFICATE=new ResourceType("AWS::IoT::CACertificate"),ResourceType.IOT_TWIN_MAKER_SYNC_JOB=new ResourceType("AWS::IoTTwinMaker::SyncJob"),ResourceType.KAFKA_CONNECT_CONNECTOR=new ResourceType("AWS::KafkaConnect::Connector"),ResourceType.LAMBDA_CODE_SIGNING_CONFIG=new ResourceType("AWS::Lambda::CodeSigningConfig"),ResourceType.RESOURCE_EXPLORER2_INDEX=new ResourceType("AWS::ResourceExplorer2::Index"),ResourceType.CONNECT_INSTANCE=new ResourceType("AWS::Connect::Instance"),ResourceType.EC2_IPAM_POOL=new ResourceType("AWS::EC2::IPAMPool"),ResourceType.EC2_TRANSIT_GATEWAY_MULTICAST_DOMAIN=new ResourceType("AWS::EC2::TransitGatewayMulticastDomain");function renderScope(ruleScope){return ruleScope?{complianceResourceId:ruleScope.resourceId,complianceResourceTypes:ruleScope.resourceTypes?.map(resource=>resource.complianceResourceType),tagKey:ruleScope.key,tagValue:ruleScope.value}:void 0}
